/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: abook-loadsave.h,v 1.3 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _ABOOK_LOADSAVE_H_
#define _ABOOK_LOADSAVE_H_

#include "puma.h"

void gal_load (char *filename);
int abook_unlink (char *name);
void abooks_read ();
void abook_load (char *dir, char *name);
void abook_load_ver_0000 (pfile *pf, Abook *book);
void abook_load_ver_0001 (pfile *pf, Abook *book);
void abooks_load_all ();
void abook_save (Abook *abook);
void abooks_save_all ();

#endif /* _ABOOK_LOADSAVE_H_ */
