/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: abook-main.h,v 1.7 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <time.h>
#include <sys/utsname.h>
#include <dirent.h>
#include <errno.h>
#include <netdb.h>
#include <unistd.h>
#include <ctype.h>

#ifndef _ABOOK_MAIN_H_
#define _ABOOK_MAIN_H_

#include "abook-opts.h"
#include "abook-callbacks.h"
#include "abook-loadsave.h"
#include "abook-window.h"

#include "tcldap.h"

/* for langauge support */
#include "lang-support.h"

#ifdef MEMWATCH
#include "memwatch.h"
#endif

#ifdef DMALLOC
#include "dmalloc.h"
#endif

GtkWidget* lookup_widget (GtkWidget *widget, const gchar *widget_name);

#endif
