/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: calender-window.h,v 1.8 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _CALENDER_WINDOW_H_
#define _CALENDER_WINDOW_H_
#include "puma.h"

#define NUM_CATEGORIES 21

char **event_get_master_categories ();
GtkWidget *create_main_calendar (void);
GtkWidget *main_calendar_create ();
GtkWidget *create_event_editor ();
GtkWidget *calendar_event_new_window (char *title, 
                                      int year, int month, int date);
void calendar_todo_select (GtkWidget *, gpointer);

GtkWidget *calendar_event_create_tree_item (GtkTree *tree, char *name, AttendeePriority prior);
GtkWidget *event_master_category_create (GtkWidget *caller_widget, char *stuff);
void event_select_attendees (GtkWidget *widget, GtkTree *tree);
GtkWidget *calendar_todo_add (GtkTree *tree, char *text, char *due, int sensitive);
int gc (char c);

#endif /* _CALENDAR_WINDOW_H_ */
