/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: conv.h,v 1.3 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>

#define lw(p, o) lookup_widget (p, o)

// signal connect: object, parent, signal, function, data
/*#define sc(o, p, s, f, d) (gtk_signal_connect (GTK_OBJECT (lw (p, o)), s, \
                                               GTK_SIGNAL_FUNC (f), (gpointer)d))*/
// container add 
#define ca(p, o) (gtk_container_add (GTK_CONTAINER (p), o))

// widget show
#define ws(p) (gtk_widget_show (p))

// protect widget
#define prot(o) (gtk_widget_set_sensitive (o, FALSE))
#define prot2(p, n) (gtk_widget_set_sensitive (lw (p, n), FALSE))

// unprotect widget
#define unprot(o) (gtk_widget_set_sensitive (o, TRUE))
#define unprot2(p, n) (gtk_widget_set_sensitive (lw (p, n), TRUE))

// box pack start
#define bps(p, o) (gtk_box_pack_start (GTK_BOX (p), o, TRUE, TRUE, 0))

// used in if statements to see if toggle button is active
#define TBA(p, obj) GTK_TOGGLE_BUTTON(lw (p, obj))->active

// does a gtk_entry_get_text (
#define gt(p, obj) gtk_entry_get_text (GTK_ENTRY (lw (p, obj)))

// gtk_spin_button_get_value_as_int ;)
#define gv(p, obj) gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (lw (p, obj)))

// set value
#define sv(p, obj, val) gtk_spin_button_set_value (GTK_SPIN_BUTTON (lw (p, obj)), val)

// sets a toggle, check or radio to active 
#define tba(p, obj) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lw (p, obj)), TRUE);

// sets a toggle, check or radio to inactive
#define tbn(p, obj) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (lw (p, obj)), FALSE);

// shortcut to GTK_OBJECT
#define ob(p, obj) GTK_OBJECT (lw (p, obj))

// shortcut to GTK_SIGNAL_FUNC
#define sf(obj) GTK_SIGNAL_FUNC (obj)

// shortcut to lookup_widget (widget, 
#define lw2(obj) lw(widget, obj)

// signal connect: object, parent, signal, function, data
#define sc(o, p, s, f, d) (gtk_signal_connect (ob (p, o), s, sf (f), (gpointer)d))

/* configuration routines */
void st (GtkWidget *parent, char *object, char *text);
void deflt (GtkWidget *widget);
/* creation routines */

void seper_new (GtkWidget *menu);
GtkWidget *menubar_new (GtkWidget *parent);	
GtkWidget *menuitem_new (GtkWidget *menu, GtkWidget *parent, char *name, char *label, 
                         GtkAccelGroup *group, guint key, guint mask);
GtkWidget *menuitem2_new (GtkWidget *menu, char *label);
GtkWidget *menu_new (GtkWidget *mitem, GtkWidget *p, GtkAccelGroup **g);
GtkWidget *button_new (GtkWidget *parent, char *name, char *label);	
GtkWidget *button2_new (GtkWidget *parent, char *name, GtkWidget *child);
GtkWidget *vb_new (GtkWidget *parent, gboolean one, gint two);
GtkWidget *hb_new (GtkWidget *parent, gboolean one, gint two);
GtkWidget *window_new (char *name, char *title, int x, int y, int w, int h);
GtkWidget *dialog_new (char *name, char *title, int x, int y, int w, int h);
GtkWidget *frame_new (GtkWidget *parent, char *name, char *label, guint border);
GtkWidget *entry_new (GtkWidget *parent, char *name);
GtkWidget* lookup_widget (GtkWidget *widget, const gchar *widget_name);

