/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: dialogs.h,v 1.6 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _DIALOGS_H_
#define _DIALOGS_H_
#include "puma.h"

GtkWidget* create_enter_password (PopAccount *);
GtkWidget* create_about_box ();
void create_popup_window (Message *message);
GtkWidget* create_message_popup ();
GtkWidget* create_folder_popup ();
GtkWidget* create_yesno ();
GtkWidget* create_yesno (char *question, char *explanation, GtkSignalFunc func,
                         gpointer data);
void destroy_yesno (GtkWidget *widget, gpointer data);
GtkWidget* create_doc_source (void);
void destroy_doc_source ();
void create_docsource_stream (char *stream);
GtkWidget* create_fileselection1 (void);

GtkWidget *mime_popup_new (Attachment *att);
void mime_attachment_unknown (char *att);
void mime_unknown_accept (GtkWidget *widget, gpointer data);
void mime_unknown_cancel (GtkWidget *widget, gpointer data);

GtkWidget* create_mime_popup (void);
void return_receipt (char *sender, char *subject, char *message);
void browse_handler(GtkWidget *);
void update_filesel (GtkWidget *widget, char *filename, gpointer data);

#endif /* _DIALOGS_H_ */
