/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: forking.h,v 1.7 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _FORKING_H_
#define _FORKING_H_

#include "puma.h"

void fork_receive_messages (int id);
int fork_receive_message1 (int popid, int announce );
void fork_send_message (PopAccount *pop, char *full_message, char *recipline);
void new_fork_send_message (PopAccount *pop, MailMessage *message, char *recipline);
int get_message_timeout (gpointer data);
int status_pipe_timeout (gpointer data);
int send_message_timeout (StupidFunc *func);

void que_remove (void);

/* IPC stuff */
void que_sem_init( void ) ;
void que_sem_deinit( void ) ;
#endif /* _FORKING_H_ */
