/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: gcalendar.h,v 1.5 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#define TM_YEAR_BASE 1900


typedef struct _CalendarData {
  GtkWidget *flag_checkboxes[5];
  gboolean  settings[5];
  gchar     *font;
  GtkWidget *font_dialog;
  GtkWidget *window;
  GtkWidget *selected;
  GtkWidget *selected_double_click;
  GtkWidget *month;
} CalendarData;

void create_calendar(int, GtkWidget *);
void day_selected_double_click (GtkWidget *widget, gpointer data);
void calendar_day_selected_double_click_msgexp (GtkWidget *widget, CalendarData *data);
void calendar_day_selected_double_click_replyby (GtkWidget *widget, CalendarData *data);

void cancel_callback(GtkWidget *widget, gpointer data);

void calendar_set_flags(CalendarData *calendar);
void calendar_create_window(GtkWidget * ignored, CalendarData * calendar);
