/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: main.h,v 1.6 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _MAIN_H_
#define _MAIN_H_

#include "puma.h"

char *stringdup (char *str);
char *unique_name (unsigned int seed, int length);
char *bits32 (unsigned long);
char *bits8 (int);
int count_delimiters (char *stream, char delim);
char *remove_charecter (char *stream, char delim);
char *rm_cr (char *string);
char *rm_crlf (char *string);
char *add_cr (char *string);
char *cut_string(char *string, char delimiter, int side, int occurrence);
int strip_lead_spaces( char *string ) ;
char *insert_reply_indicator (char *body);
void puma_error (char *, ...);
void puma_warning (int, char *, ...);
void puma_message (int, char *, ...);
void puma_debug (int, char *, ...);
void startup ();
void grey_out_stuff ();

#ifdef WANTLDAP
int gab_update_search (gpointer data, char *target);
void gab_update_wrapper (gpointer data) ;
#endif

#endif /* _MAIN_H_ */
