/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: message-callbacks.h,v 1.3 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _MESSAGE_CALLBACKS_H_
#define _MESSAGE_CALLBACKS_H_
#include "puma.h"

void message_window_destroy (GtkWidget *widget, GdkEvent *event, gpointer data);
void message_window_close (GtkWidget *widget, gpointer data);
void message_window_replyto (GtkWidget *widget, gpointer data);
void message_window_replytoall (GtkWidget *widget, gpointer data);
void message_window_forward (GtkWidget *widget, gpointer data);
void message_window_save (GtkWidget *widget, gpointer data);

void message_window_print (GtkWidget *widget, gpointer data);
void message_attachment_event (GtkWidget *widget, GdkEventButton *event, 
                               gpointer data);

#endif /* _MESSAGE_CALLBACKS_H_ */
