/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: msearch.h,v 1.11 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

void msearch_destroy (GtkObject * object, gpointer user_data);
void on_search_folder_changed (GtkEditable * editable, gpointer user_data);
void on_search_attribute_changed (GtkEditable * editable, gpointer user_data);
void on_search_criteria_changed (GtkEditable * editable, gpointer user_data);
void on_child_button_toggled (GtkWidget * widget, gpointer user_data);
void on_case_button_toggled (GtkWidget * widget, gpointer user_data);
void on_any_button_toggled (GtkWidget * widget, gpointer user_data);
void on_all_button_toggled (GtkWidget * widget, gpointer user_data);
void on_search_text_changed (GtkEditable * editable, gpointer user_data);
GtkWidget *on_add_button_clicked (GtkWidget * placeholder, GtkTree * tree);
void search_tree_selected (GtkTree * tree, GtkWidget * child);
void treeitem_button_event (GtkWidget * widget, GdkEventButton * event,
			    gpointer user_data);
void msearch_search (GtkWidget * widget, gpointer user_data);
void treeitem_delete (GtkWidget * widget, gpointer user_data);
GtkWidget *treeitem_popup (void);
GtkWidget *create_msearch_window (void);
void msearch_destroy_clist_contents (GtkCList * clist);
void search_english_update (GtkWidget * text);
void on_message_clist_button_press_event (GtkWidget * widget,
					  GdkEventButton * event,
					  gpointer user_data);
int msearch_check (char *this, char *that, int equal, int sim, int ignore);
char *msearch_lower (char *string);
void msearch_cancel(void);
