/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: pref-windows.h,v 1.7 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _PREF_WINDOWS_H_
#define _PREF_WINDOWS_H_

#include "puma.h"

GtkWidget *create_preference_dialog ();
GtkWidget *create_server_type ();
GtkWidget *create_pop3_server_info ();
GtkWidget *create_mime_type_window (void);
GtkWidget *server_create_info (gpointer data);
int prefs_setup_info ();
GtkWidget* prefs_server_window (PopAccount *ok_data, PopAccount *cancel_data);
#ifdef WANTSSL
void ssl_toggled(GtkWidget *, gpointer);
void ldapssl_toggled(GtkWidget *, gpointer);
#endif

#endif /* _PREF_WINDOWS_H_ */
