/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: status-callbacks.h,v 1.3 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _STATUS_CALLBACKS_H_
#define _STATUS_CALLBACKS_H_

void stop_transaction_clicked (GtkWidget *widget, gpointer data);
void skip_account_clicked (GtkWidget *widget, gpointer data);
void status_toggle_error_only (GtkWidget *widget, gpointer data);
void status_toggle_hide_when_done (GtkWidget *widget, gpointer data);

void destroy_status (GtkWidget *widget, gpointer data);
void show_status (GtkWidget *widget, gpointer data);

#endif /* _STATUS_CALLBACKS_H_ */
