/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: tcldap.h,v 1.5 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


extern char gabName[] ;

#ifdef WANTLDAP

#ifndef _LDAP_H_
#define _LDAP_H_

#include <lber.h>
#include <ldap.h>
#include "abook-main.h"

void insert_wanted_value (LDAP *ld, LDAPMessage *ldmsg, char *attr,
                          Abook_entry *abooke);
LDAP *ldap_logon (char *host, int port, char *dn, char *pass);
void ldap_logoff (LDAP *ld);
int ldap_get_GAB (LDAP *ld, char *basedn, char *filter);
void update_gab (char *host, int port, char *basedn, char *udn, char *passwd, char *filter);


#endif /* _LDAP_H_ */

#endif /* WANTLDAP */
