/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: pref-windows.c,v 1.48 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

gint dummy=0;

GtkWidget* create_preference_dialog2 (void) {
  GtkWidget *preference_dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *frame12;
  GtkWidget *hbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *server_clist;
  GtkWidget *label10;
  GtkWidget *label11;
  GtkWidget *vbox1;
//  GtkWidget *add_server_button;
	GtkWidget *menubar;
	GtkWidget *menuitem;
	GtkWidget *menuitem_menu;
	GtkWidget *pop3, *imap;
  GtkWidget *edit_server_button;
  GtkWidget *delete_server_button;
  GtkWidget *label3;
  GtkWidget *frame4;
  GtkWidget *table2;
  GtkWidget *label23;
  GtkWidget *name_entry;
  GtkWidget *label24;
  GtkWidget *reply_entry;
  GtkWidget *label25;
  GtkWidget *org_entry;
  GtkWidget *hbox10;
  GtkWidget *use_autosig;
  GtkWidget *label46;
  GtkWidget *use_unix_sig;
  GtkWidget *label47;
  GtkWidget *hbox9;
  GtkWidget *scrolledwindow2;
  GtkWidget *autosignature;
  GtkWidget *vbox4;
  GtkWidget *insert_autosig;
  GtkWidget *label29;
  GtkWidget *email_addy_entry;
  GtkWidget *label30;
  GtkWidget *combo2;
  GtkWidget *combo_entry2;
  GtkWidget *label4;
#ifdef WANTLDAP
  GtkWidget *l_frame, *l_table, *l_tablabel;
#ifdef WANTSSL
  GtkWidget *l_ssl;
#endif
  GtkWidget *l_label_host, *l_entry_host;
  GtkWidget *l_label_port, *l_entry_port;
  GtkObject *l_entry_port_adj;
  GtkWidget *l_label_username, *l_entry_username;
  GtkWidget *l_label_password, *l_entry_password;
  GtkWidget *l_label_base, *l_entry_base;
#endif
  GtkWidget *frame11;
  GtkWidget *hbox14;
  GtkWidget *scrolledwindow3;
  GtkWidget *mime_clist;
  GtkWidget *label37;
  GtkWidget *label38;
  GtkWidget *label39;
  GtkWidget *vbox6;
  GtkWidget *add_type;
  GtkWidget *edit_type;
  GtkWidget *delete_type;
  GtkWidget *label36;
  GtkWidget *frame10;
  GtkWidget *hbox16;
  GtkWidget *scrolledwindow4;
  GtkWidget *rule_clist;
  GtkWidget *rules_label;
  GtkWidget *vbox7;
  GtkWidget *add_rule;
  GtkWidget *edit_rule;
  GtkWidget *delete_rule;
  GtkWidget *pr_frame;
  GtkWidget *hbox26;
  GtkWidget *arrow1;
  GtkWidget *filter_up;
  GtkWidget *arrow2;
  GtkWidget *filter_down;
  GtkWidget *label43;
  GtkWidget *frame7;
  GtkWidget *vbox5;
  GtkWidget *hbox13;
  GtkWidget *label34;
  GtkObject *timeout_adj;
  GtkWidget *timeout;
  GtkWidget *label35;
  GtkWidget *hbox17;
  GtkWidget *hide_status;
  GtkWidget *hbox18;
  GtkWidget *frame13;
  GtkWidget *vbox8;
  GSList *header_info_group = NULL;
  GtkWidget *header_none;
  GtkWidget *header_some;
  GtkWidget *header_all;
  GtkWidget *frame14;
  GtkWidget *vbox9;
  GSList *replying_group = NULL;
  GtkWidget *reply_none;
  GtkWidget *reply_attach;
  GtkWidget *reply_quoted;
  GtkWidget *frame15;
  GtkWidget *vbox10;
  GtkWidget *hbox23;
  GtkWidget *label53;
  GtkWidget *wasted_space;
  GtkWidget *hbox24;
  GtkWidget *label54;
  GtkWidget *wasted_warning;
  GtkWidget *hbox25;
  GtkWidget *undelete;
  GtkWidget *compact;
  GtkWidget *label31;
  /* trey */
#if 0
  GtkWidget *fonts_frame, *fonts_label;
  GtkWidget *colors_frame, *colors_label;
#endif
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox8;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  preference_dialog = gtk_dialog_new ();
  gtk_widget_set_name (preference_dialog, "preference_dialog");
  gtk_object_set_data (GTK_OBJECT (preference_dialog), "preference_dialog", preference_dialog);
  gtk_window_set_title (GTK_WINDOW (preference_dialog), "Preferences");
#if 0
  gtk_window_set_modal (GTK_WINDOW (preference_dialog), TRUE);
#endif
  gtk_window_set_policy (GTK_WINDOW (preference_dialog), TRUE, TRUE, TRUE);
  gtk_window_set_default_size (GTK_WINDOW (preference_dialog), 500, -1);

  dialog_vbox1 = GTK_DIALOG (preference_dialog)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (preference_dialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_set_name (notebook1, "notebook1");
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook1, TRUE, TRUE, 0);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook1), TRUE);
  gtk_notebook_set_homogeneous_tabs (GTK_NOTEBOOK (notebook1), FALSE);

  frame12 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame12, "frame12");
  gtk_widget_ref (frame12);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame12", frame12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame12);
  gtk_container_add (GTK_CONTAINER (notebook1), frame12);
  gtk_container_set_border_width (GTK_CONTAINER (frame12), 2);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame12), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  server_clist = gtk_clist_new (2);
  gtk_widget_set_name (server_clist, "server_clist");
  gtk_widget_ref (server_clist);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "server_clist", server_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (server_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), server_clist);
  gtk_clist_set_column_width (GTK_CLIST (server_clist), 0, 250);
//  gtk_clist_set_column_width (GTK_CLIST (server_clist), 1, 12);
  gtk_clist_column_titles_show (GTK_CLIST (server_clist));

  label10 = gtk_label_new ("Name");
  gtk_widget_set_name (label10, "label10");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_clist_set_column_widget (GTK_CLIST (server_clist), 0, label10);

  label11 = gtk_label_new ("Type");
  gtk_widget_set_name (label11, "label11");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_clist_set_column_widget (GTK_CLIST (server_clist), 1, label11);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 2);

  menubar = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar, "menubar");
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "menubar", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar, TRUE, FALSE, 0);
	
  menuitem = gtk_menu_item_new_with_label ("Add Server");
  gtk_widget_set_name (menuitem, "menuitem");
  gtk_widget_ref (menuitem);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "menuitem", menuitem,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem);
  gtk_container_add (GTK_CONTAINER (menubar), menuitem);

  menuitem_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem_menu, "menuitem_menu");
  gtk_widget_ref (menuitem_menu);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "menuitem_menu", menuitem_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem), menuitem_menu);

  pop3 = gtk_menu_item_new_with_label ("POP3");
  gtk_widget_set_name (pop3, "pop3");
  gtk_widget_ref (pop3);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "pop3", pop3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pop3);
  gtk_container_add (GTK_CONTAINER (menuitem_menu), pop3);

  imap = gtk_menu_item_new_with_label ("IMAP");
  gtk_widget_set_name (imap, "imap");
  gtk_widget_ref (imap);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "imap", imap,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (imap);
  gtk_container_add (GTK_CONTAINER (menuitem_menu), imap);

  /*add_server_button = gtk_button_new_with_label ("Add Account");
  gtk_widget_set_name (add_server_button, "add_server_button");
  gtk_widget_ref (add_server_button);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "add_server_button", add_server_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_server_button);
  gtk_box_pack_start (GTK_BOX (vbox1), add_server_button, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, add_server_button, "Add an email account to the list of accounts", NULL);*/

  edit_server_button = gtk_button_new_with_label ("Edit Server");
  gtk_widget_set_name (edit_server_button, "edit_server_button");
  gtk_widget_ref (edit_server_button);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "edit_server_button", edit_server_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_server_button);
  gtk_box_pack_start (GTK_BOX (vbox1), edit_server_button, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, edit_server_button, "Edit the currently selected server", NULL);

  delete_server_button = gtk_button_new_with_label ("Delete Server");
  gtk_widget_set_name (delete_server_button, "delete_server_button");
  gtk_widget_ref (delete_server_button);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "delete_server_button", delete_server_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_server_button);
  gtk_box_pack_start (GTK_BOX (vbox1), delete_server_button, TRUE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, delete_server_button, "Delete selected server from the list", NULL);

  label3 = gtk_label_new ("Mail Servers");
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label3);
  frame4 = gtk_frame_new ("Global Outgoing Mail Settings");
  gtk_widget_set_name (frame4, "frame4");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_container_add (GTK_CONTAINER (notebook1), frame4);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 2);

  table2 = gtk_table_new (7, 2, FALSE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame4), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 2);

  label23 = gtk_label_new ("Your Name");
  gtk_widget_set_name (label23, "label23");
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_table_attach (GTK_TABLE (table2), label23, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label23);

  name_entry = gtk_entry_new ();
  gtk_widget_set_name (name_entry, "name_entry");
  gtk_widget_ref (name_entry);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "name_entry", name_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (name_entry);
  gtk_table_attach (GTK_TABLE (table2), name_entry, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  label24 = gtk_label_new ("Reply To Address");
  gtk_widget_set_name (label24, "label24");
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_table_attach (GTK_TABLE (table2), label24, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label24);

  reply_entry = gtk_entry_new ();
  gtk_widget_set_name (reply_entry, "reply_entry");
  gtk_widget_ref (reply_entry);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "reply_entry", reply_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_entry);
  gtk_table_attach (GTK_TABLE (table2), reply_entry, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  label25 = gtk_label_new ("Organization");
  gtk_widget_set_name (label25, "label25");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_table_attach (GTK_TABLE (table2), label25, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label25);

  org_entry = gtk_entry_new ();
  gtk_widget_set_name (org_entry, "org_entry");
  gtk_widget_ref (org_entry);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "org_entry", org_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (org_entry);
  gtk_table_attach (GTK_TABLE (table2), org_entry, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox10, "hbox10");
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_table_attach (GTK_TABLE (table2), hbox10, 0, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  use_autosig = gtk_check_button_new_with_label ("");
  gtk_widget_set_name (use_autosig, "use_autosig");
  gtk_widget_ref (use_autosig);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "use_autosig", use_autosig,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (use_autosig);
  gtk_box_pack_start (GTK_BOX (hbox10), use_autosig, FALSE, TRUE, 0);

  label46 = gtk_label_new ("Add this signature to the end of all outgoing messages");
  gtk_widget_set_name (label46, "label46");
  gtk_widget_ref (label46);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label46", label46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (hbox10), label46, FALSE, TRUE, 0);

  use_unix_sig = gtk_check_button_new_with_label ("");
  gtk_widget_set_name (use_unix_sig, "use_unix_sig");
  gtk_widget_ref (use_unix_sig);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "use_unix_sig", use_unix_sig,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (use_unix_sig);
  gtk_box_pack_start (GTK_BOX (hbox10), use_unix_sig, FALSE, FALSE, 0);

  label47 = gtk_label_new ("Use ~/.sig");
  gtk_widget_set_name (label47, "label47");
  gtk_widget_ref (label47);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label47", label47,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label47);
  gtk_box_pack_start (GTK_BOX (hbox10), label47, FALSE, FALSE, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox9, "hbox9");
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_table_attach (GTK_TABLE (table2), hbox9, 0, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow2, "scrolledwindow2");
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (hbox9), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  autosignature = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (autosignature, "autosignature");
  gtk_widget_ref (autosignature);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "autosignature", autosignature,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (autosignature);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), autosignature);
  gtk_text_set_editable (GTK_TEXT (autosignature), TRUE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox4, FALSE, TRUE, 0);

  insert_autosig = gtk_button_new_with_label ("Insert File...");
  gtk_widget_set_name (insert_autosig, "insert_autosig");
  gtk_widget_ref (insert_autosig);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "insert_autosig", insert_autosig,
                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (insert_autosig);
  gtk_box_pack_start (GTK_BOX (vbox4), insert_autosig, TRUE, FALSE, 0);

  label29 = gtk_label_new ("Email Address");
  gtk_widget_set_name (label29, "label29");
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_table_attach (GTK_TABLE (table2), label29, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label29);

  email_addy_entry = gtk_entry_new ();
  gtk_widget_set_name (email_addy_entry, "email_addy_entry");
  gtk_widget_ref (email_addy_entry);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "email_addy_entry", email_addy_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_addy_entry);
  gtk_table_attach (GTK_TABLE (table2), email_addy_entry, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  label30 = gtk_label_new ("Default Outgoing account");
  gtk_widget_set_name (label30, "label30");
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_table_attach (GTK_TABLE (table2), label30, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label30);

  combo2 = gtk_combo_new ();
  gtk_widget_set_name (combo2, "combo2");
  gtk_widget_ref (combo2);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "combo2", combo2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo2);
  gtk_table_attach (GTK_TABLE (table2), combo2, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  combo_entry2 = GTK_COMBO (combo2)->entry;
  gtk_widget_set_name (combo_entry2, "combo_entry2");
  gtk_widget_ref (combo_entry2);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "combo_entry2", combo_entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry2);

  label4 = gtk_label_new ("Mail Settings");
  gtk_widget_set_name (label4, "label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label4);

#ifdef WANTLDAP
  
  l_frame = gtk_frame_new ("Global LDAP Settings");
  gtk_widget_set_name (l_frame, "l_frame");
  gtk_widget_ref (l_frame);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_frame", l_frame,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_frame);
  gtk_container_add (GTK_CONTAINER (notebook1), l_frame);
  gtk_container_set_border_width (GTK_CONTAINER (l_frame), 2);

  l_table = gtk_table_new (4, 3, FALSE);
  gtk_widget_set_name (l_table, "l_table");
  gtk_widget_ref (l_table);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_table", l_table,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_table);
  gtk_container_add (GTK_CONTAINER (l_frame), l_table);
  gtk_container_set_border_width (GTK_CONTAINER (l_table), 2);

  l_label_host = gtk_label_new ("LDAP Host");
  gtk_widget_set_name (l_label_host, "l_label_host");
  gtk_widget_ref (l_label_host);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_label_host", l_label_host,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_label_host);
  gtk_table_attach (GTK_TABLE (l_table), l_label_host, 0, 1, 0, 1,
		  (GtkAttachOptions) (GTK_FILL), 
		  (GtkAttachOptions) (0), 2, 0);
  right_align (l_label_host);

  l_entry_host = gtk_entry_new ();
  gtk_widget_set_name (l_entry_host, "l_entry_host");
  gtk_widget_ref (l_entry_host);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_entry_host",
		  l_entry_host,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_entry_host);
  gtk_table_attach (GTK_TABLE (l_table), l_entry_host, 1, 3, 0, 1,
		  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		  (GtkAttachOptions) (0), 2, 0);

  l_label_port = gtk_label_new ("LDAP Port");
  gtk_widget_set_name (l_label_port, "l_label_port");
  gtk_widget_ref (l_label_port);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_label_port", l_label_port,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_label_port);
  gtk_table_attach (GTK_TABLE (l_table), l_label_port, 0, 1, 1, 2,
		  (GtkAttachOptions) (GTK_FILL),
		  (GtkAttachOptions) (0), 2, 0);
  right_align (l_label_port);

  l_entry_port_adj = gtk_adjustment_new (389, 1, 65056, 1, 10, 10);
  l_entry_port = gtk_spin_button_new (GTK_ADJUSTMENT (l_entry_port_adj), 1, 0); 
  gtk_widget_set_name (l_entry_port, "l_entry_port"); 
  gtk_widget_ref (l_entry_port); 
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_entry_port",
		  l_entry_port, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_entry_port); 
  gtk_table_attach (GTK_TABLE (l_table), l_entry_port, 1, 2, 1, 2,
		  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		  (GtkAttachOptions) (0), 2, 0);

#ifdef WANTSSL
  l_ssl = gtk_check_button_new_with_label("SSL connection");
  gtk_widget_set_name (l_ssl, "l_ssl");
  gtk_widget_ref (l_ssl);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_ssl",
                  l_ssl, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_ssl);
  if (tm_globs->ldap_ssl)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (l_ssl), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (l_ssl), FALSE);
  gtk_table_attach (GTK_TABLE (l_table), l_ssl, 2, 3, 1, 2,
                  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                  (GtkAttachOptions) (0), 2, 0);
  gtk_signal_connect (GTK_OBJECT (l_ssl), "toggled",
        GTK_SIGNAL_FUNC (ldapssl_toggled), NULL);
#endif

  if(!tm_globs->ldap_port)
    tm_globs -> ldap_port = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (l_entry_port));
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (l_entry_port), tm_globs->ldap_port);

  l_label_username = gtk_label_new ("Username");
  gtk_widget_set_name (l_label_username, "l_label_username");
  gtk_widget_ref (l_label_username);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_label_username", l_label_username,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_label_username);
  gtk_table_attach (GTK_TABLE (l_table), l_label_username, 0, 1, 2, 3,
		  (GtkAttachOptions) (GTK_FILL), 
		  (GtkAttachOptions) (0), 2, 0);
  right_align (l_label_username);

  l_entry_username = gtk_entry_new ();
  gtk_widget_set_name (l_entry_username, "l_entry_username");
  gtk_widget_ref (l_entry_username);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_entry_username",
		  l_entry_username,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_entry_username);
  gtk_table_attach (GTK_TABLE (l_table), l_entry_username, 1, 3, 2, 3,
		  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		  (GtkAttachOptions) (0), 2, 0);

  l_label_password = gtk_label_new ("Password");
  gtk_widget_set_name (l_label_password, "l_label_password");
  gtk_widget_ref (l_label_password);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_label_password", l_label_password,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_label_password);
  gtk_table_attach (GTK_TABLE (l_table), l_label_password, 0, 1, 3, 4,
		  (GtkAttachOptions) (GTK_FILL), 
		  (GtkAttachOptions) (0), 2, 0);
  right_align (l_label_password);

  l_entry_password = gtk_entry_new ();
  gtk_widget_set_name (l_entry_password, "l_entry_password");
  gtk_widget_ref (l_entry_password);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_entry_password",
		  l_entry_password,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_entry_password);
  gtk_table_attach (GTK_TABLE (l_table), l_entry_password, 1, 3, 3, 4,
		  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		  (GtkAttachOptions) (0), 2, 0);
  gtk_entry_set_visibility (GTK_ENTRY (l_entry_password), FALSE);

  l_label_base = gtk_label_new ("Search Base");
  gtk_widget_set_name (l_label_base, "l_label_base");
  gtk_widget_ref (l_label_base);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_label_base", l_label_base,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_label_base);
  gtk_table_attach (GTK_TABLE (l_table), l_label_base, 0, 1, 4, 5,
		  (GtkAttachOptions) (GTK_FILL), 
		  (GtkAttachOptions) (0), 2, 0);
  right_align (l_label_base);

  l_entry_base = gtk_entry_new ();
  gtk_widget_set_name (l_entry_base, "l_entry_base");
  gtk_widget_ref (l_entry_base);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_entry_base",
		  l_entry_base,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_entry_base);
  gtk_table_attach (GTK_TABLE (l_table), l_entry_base, 1, 3, 4, 5,
		  (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		  (GtkAttachOptions) (0), 2, 0);

  l_tablabel = gtk_label_new ("LDAP Service");
  gtk_widget_set_name (l_tablabel, "l_tablabel");
  gtk_widget_ref (l_tablabel);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "l_tablabel",
		  l_tablabel, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_tablabel);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
		  gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2),
		  l_tablabel);

#endif

  frame11 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame11, "frame11");
  gtk_widget_ref (frame11);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame11", frame11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame11);
  gtk_container_add (GTK_CONTAINER (notebook1), frame11);
  gtk_container_set_border_width (GTK_CONTAINER (frame11), 2);

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox14, "hbox14");
  gtk_widget_ref (hbox14);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox14", hbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox14);
  gtk_container_add (GTK_CONTAINER (frame11), hbox14);
  gtk_container_set_border_width (GTK_CONTAINER (hbox14), 2);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow3, "scrolledwindow3");
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (hbox14), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  mime_clist = gtk_clist_new (3);
  gtk_widget_set_name (mime_clist, "mime_clist");
  gtk_widget_ref (mime_clist);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "mime_clist", mime_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mime_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), mime_clist);
  gtk_clist_set_column_width (GTK_CLIST (mime_clist), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (mime_clist), 1, 131);
  gtk_clist_set_column_width (GTK_CLIST (mime_clist), 2, 65);
  gtk_clist_column_titles_show (GTK_CLIST (mime_clist));

  label37 = gtk_label_new ("Extensions");
  gtk_widget_set_name (label37, "label37");
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_clist_set_column_widget (GTK_CLIST (mime_clist), 0, label37);

  label38 = gtk_label_new ("MIME Type");
  gtk_widget_set_name (label38, "label38");
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label38);
  gtk_clist_set_column_widget (GTK_CLIST (mime_clist), 1, label38);

  label39 = gtk_label_new ("Renderer");
  gtk_widget_set_name (label39, "label39");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label39);
  gtk_clist_set_column_widget (GTK_CLIST (mime_clist), 2, label39);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox6, "vbox6");
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox14), vbox6, FALSE, FALSE, 0);

  add_type = gtk_button_new_with_label ("Add Type");
  gtk_widget_set_name (add_type, "add_type");
  gtk_widget_ref (add_type);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "add_type", add_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_type);
  gtk_box_pack_start (GTK_BOX (vbox6), add_type, TRUE, FALSE, 0);

  edit_type = gtk_button_new_with_label ("Edit Type");
  gtk_widget_set_name (edit_type, "edit_type");
  gtk_widget_ref (edit_type);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "edit_type", edit_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_type);
  gtk_box_pack_start (GTK_BOX (vbox6), edit_type, TRUE, FALSE, 0);

  delete_type = gtk_button_new_with_label ("Delete Type");
  gtk_widget_set_name (delete_type, "delete_type");
  gtk_widget_ref (delete_type);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "delete_type", delete_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_type);
  gtk_box_pack_start (GTK_BOX (vbox6), delete_type, TRUE, FALSE, 0);

  label36 = gtk_label_new ("MIME Types");
  gtk_widget_set_name (label36, "label36");
  gtk_widget_ref (label36);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label36", label36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label36);
#ifdef WANTLDAP
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), label36);
#else
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label36);
#endif

  frame10 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame10, "frame10");
  gtk_widget_ref (frame10);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame10", frame10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame10);
  gtk_container_add (GTK_CONTAINER (notebook1), frame10);
  gtk_container_set_border_width (GTK_CONTAINER (frame10), 2);

  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox16, "hbox16");
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_container_add (GTK_CONTAINER (frame10), hbox16);
  gtk_container_set_border_width (GTK_CONTAINER (hbox16), 2);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow4, "scrolledwindow4");
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (hbox16), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  rule_clist = gtk_clist_new (1);
  gtk_widget_set_name (rule_clist, "rule_clist");
  gtk_widget_ref (rule_clist);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "rule_clist", rule_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rule_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), rule_clist);
  gtk_clist_set_column_width (GTK_CLIST (rule_clist), 0, 80);
  gtk_clist_column_titles_show (GTK_CLIST (rule_clist));
  gtk_clist_set_column_auto_resize (GTK_CLIST (rule_clist), 0, TRUE);

  rules_label = gtk_label_new ("Mail Filtering Rules");
  gtk_widget_set_name (rules_label, "rules_label");
  gtk_widget_ref (rules_label);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "rules_label", rules_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rules_label);
  gtk_clist_set_column_widget (GTK_CLIST (rule_clist), 0, rules_label);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox7, "vbox7");
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_box_pack_start (GTK_BOX (hbox16), vbox7, FALSE, FALSE, 0);

  add_rule = gtk_button_new_with_label ("Add Rule");
  gtk_widget_set_name (add_rule, "add_rule");
  gtk_widget_ref (add_rule);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "add_rule", add_rule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_rule);
  gtk_box_pack_start (GTK_BOX (vbox7), add_rule, TRUE, FALSE, 0);

  edit_rule = gtk_button_new_with_label ("Edit Rule");
  gtk_widget_set_name (edit_rule, "edit_rule");
  gtk_widget_ref (edit_rule);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "edit_rule", edit_rule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_rule);
  gtk_box_pack_start (GTK_BOX (vbox7), edit_rule, TRUE, FALSE, 0);

  delete_rule = gtk_button_new_with_label ("Delete Rule");
  gtk_widget_set_name (delete_rule, "delete_rule");
  gtk_widget_ref (delete_rule);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "delete_rule", delete_rule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_rule);
  gtk_box_pack_start (GTK_BOX (vbox7), delete_rule, TRUE, FALSE, 0);

  pr_frame = gtk_frame_new (_("Set Order"));
  gtk_widget_set_name (pr_frame, "pr_frame");
  gtk_widget_ref (pr_frame);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "pr_frame", pr_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pr_frame);
  gtk_box_pack_start (GTK_BOX (vbox7), pr_frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pr_frame), 5);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox26, "hbox26");
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_container_add (GTK_CONTAINER (pr_frame), hbox26);

  filter_up = gtk_button_new ();
  gtk_widget_set_name (filter_up, "filter_up");
  gtk_widget_ref (filter_up);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "filter_up", filter_up,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filter_up);
  gtk_container_set_border_width (GTK_CONTAINER (filter_up), 5);
  gtk_box_pack_start (GTK_BOX (hbox26), filter_up, TRUE, FALSE, 0);

  arrow1 = gtk_arrow_new (GTK_ARROW_UP, GTK_SHADOW_OUT);
  gtk_widget_set_name (arrow1, "arrow1");
  gtk_widget_ref (arrow1);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "arrow1", arrow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow1);
  gtk_container_add (GTK_CONTAINER (filter_up), arrow1);

  filter_down = gtk_button_new ();
  gtk_widget_set_name (filter_down, "filter_down");
  gtk_widget_ref (filter_down);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "filter_down", filter_down,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filter_down);
  gtk_container_set_border_width (GTK_CONTAINER (filter_down), 5);
  gtk_box_pack_start (GTK_BOX (hbox26), filter_down, TRUE, FALSE, 0);

  arrow2 = gtk_arrow_new (GTK_ARROW_DOWN, GTK_SHADOW_OUT);
  gtk_widget_set_name (arrow2, "arrow2");
  gtk_widget_ref (arrow2);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "arrow2", arrow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (arrow2);
  gtk_container_add (GTK_CONTAINER (filter_down), arrow2);

  label43 = gtk_label_new ("Filtering Rules");
  gtk_widget_set_name (label43, "label43");
  gtk_widget_ref (label43);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label43", label43,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label43);
#ifdef WANTLDAP
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 4), label43);
#else
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), label43);
#endif

  frame7 = gtk_frame_new ("Miscellaneous, Non-account specific preferences");
  gtk_widget_set_name (frame7, "frame7");
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame7);
  gtk_container_add (GTK_CONTAINER (notebook1), frame7);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (frame7), vbox5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 2);

  hbox13 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox13, "hbox13");
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox13, FALSE, TRUE, 0);

  label34 = gtk_label_new ("Timeout for ");
  gtk_widget_set_name (label34, "label34");
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (label34);*/
  gtk_box_pack_start (GTK_BOX (hbox13), label34, FALSE, FALSE, 0);

  timeout_adj = gtk_adjustment_new (45, 1, 256, 1, 10, 10);
  timeout = gtk_spin_button_new (GTK_ADJUSTMENT (timeout_adj), 1, 0);
  gtk_widget_set_name (timeout, "timeout");
  gtk_widget_ref (timeout);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "timeout", timeout,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (timeout);*/
  gtk_box_pack_start (GTK_BOX (hbox13), timeout, FALSE, TRUE, 0);
  gtk_widget_set_sensitive (timeout, FALSE);

  label35 = gtk_label_new ("seconds when connecting to a server");
  gtk_widget_set_name (label35, "label35");
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (label35);*/
  gtk_box_pack_start (GTK_BOX (hbox13), label35, FALSE, FALSE, 0);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox17, "hbox17");
  gtk_widget_ref (hbox17);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox17", hbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox17, FALSE, TRUE, 0);

  hide_status = gtk_check_button_new_with_label ("Hide status window unless there is an error");
  gtk_widget_set_name (hide_status, "hide_status");
  gtk_widget_ref (hide_status);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hide_status", hide_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hide_status);
  gtk_box_pack_start (GTK_BOX (hbox17), hide_status, FALSE, FALSE, 0);

  hbox18 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox18, "hbox18");
  gtk_widget_ref (hbox18);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox18", hbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox18);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox18, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox18), 2);

  frame13 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame13, "frame13");
  gtk_widget_ref (frame13);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame13", frame13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame13);
  gtk_box_pack_start (GTK_BOX (hbox18), frame13, FALSE, FALSE, 0);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox8, "vbox8");
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (frame13), vbox8);

  header_none = gtk_radio_button_new_with_label (header_info_group, "Show no Header info");
  header_info_group = gtk_radio_button_group (GTK_RADIO_BUTTON (header_none));
  gtk_widget_set_name (header_none, "header_none");
  gtk_widget_ref (header_none);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "header_none", header_none,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (header_none);
  gtk_box_pack_start (GTK_BOX (vbox8), header_none, FALSE, FALSE, 0);

  header_some = gtk_radio_button_new_with_label (header_info_group, "Show some Header in message body");
  header_info_group = gtk_radio_button_group (GTK_RADIO_BUTTON (header_some));
  gtk_widget_set_name (header_some, "header_some");
  gtk_widget_ref (header_some);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "header_some", header_some,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (header_some);
  gtk_box_pack_start (GTK_BOX (vbox8), header_some, FALSE, FALSE, 0);

  header_all = gtk_radio_button_new_with_label (header_info_group, "Show All Header");
  header_info_group = gtk_radio_button_group (GTK_RADIO_BUTTON (header_all));
  gtk_widget_set_name (header_all, "header_all");
  gtk_widget_ref (header_all);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "header_all", header_all,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (header_all);
  gtk_box_pack_start (GTK_BOX (vbox8), header_all, FALSE, FALSE, 0);

  frame14 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame14, "frame14");
  gtk_widget_ref (frame14);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame14", frame14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame14);
  gtk_box_pack_start (GTK_BOX (hbox18), frame14, TRUE, TRUE, 0);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox9, "vbox9");
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (frame14), vbox9);

  reply_none = gtk_radio_button_new_with_label (replying_group, "Do not include body when Replying");
  replying_group = gtk_radio_button_group (GTK_RADIO_BUTTON (reply_none));
  gtk_widget_set_name (reply_none, "reply_none");
  gtk_widget_ref (reply_none);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "reply_none", reply_none,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_none);
  gtk_box_pack_start (GTK_BOX (vbox9), reply_none, FALSE, FALSE, 0);

  reply_attach = gtk_radio_button_new_with_label (replying_group, "Include Reply as Attachment");
  replying_group = gtk_radio_button_group (GTK_RADIO_BUTTON (reply_attach));
  gtk_widget_set_name (reply_attach, "reply_attach");
  gtk_widget_ref (reply_attach);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "reply_attach", reply_attach,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_attach);
  gtk_box_pack_start (GTK_BOX (vbox9), reply_attach, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (reply_attach), TRUE);

  reply_quoted = gtk_radio_button_new_with_label (replying_group, "Include Reply as Quoted");
  replying_group = gtk_radio_button_group (GTK_RADIO_BUTTON (reply_quoted));
  gtk_widget_set_name (reply_quoted, "reply_quoted");
  gtk_widget_ref (reply_quoted);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "reply_quoted", reply_quoted,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_quoted);
  gtk_box_pack_start (GTK_BOX (vbox9), reply_quoted, FALSE, FALSE, 0);

  frame15 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame15, "frame15");
  gtk_widget_ref (frame15);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "frame15", frame15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame15);
  gtk_box_pack_start (GTK_BOX (vbox5), frame15, TRUE, TRUE, 0);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox10, "vbox10");
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_container_add (GTK_CONTAINER (frame15), vbox10);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox23, "hbox23");
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox23, FALSE, FALSE, 0);

  label53 = gtk_label_new ("Current Wasted Space:");
  gtk_widget_set_name (label53, "label53");
  gtk_widget_ref (label53);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label53", label53,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label53);
  gtk_box_pack_start (GTK_BOX (hbox23), label53, FALSE, FALSE, 0);

  wasted_space = gtk_progress_bar_new ();
  gtk_widget_set_name (wasted_space, "wasted_space");
  gtk_widget_ref (wasted_space);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "wasted_space", wasted_space,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wasted_space);
  gtk_box_pack_start (GTK_BOX (hbox23), wasted_space, TRUE, TRUE, 0);
  gtk_progress_set_show_text (GTK_PROGRESS (wasted_space), TRUE);
  gtk_progress_set_format_string (GTK_PROGRESS (wasted_space), "X Bytes (%P%%)");

  hbox24 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox24, "hbox24");
  gtk_widget_ref (hbox24);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox24);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox24, TRUE, TRUE, 0);

  label54 = gtk_label_new ("Warn me when wasted space reaches: \n(0% = Never Warn)");
  gtk_widget_set_name (label54, "label54");
  gtk_widget_ref (label54);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label54", label54,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label54);
  gtk_box_pack_start (GTK_BOX (hbox24), label54, FALSE, FALSE, 0);

  wasted_warning = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 101, 1, 10, 1)));
  gtk_widget_set_name (wasted_warning, "wasted_warning");
  gtk_widget_ref (wasted_warning);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "wasted_warning", wasted_warning,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wasted_warning);
  gtk_box_pack_start (GTK_BOX (hbox24), wasted_warning, TRUE, TRUE, 0);
  gtk_range_set_update_policy (GTK_RANGE (wasted_warning), GTK_UPDATE_DELAYED);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox25, "hbox25");
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox10), hbox25, TRUE, TRUE, 0);

  undelete = gtk_button_new_with_label ("Undelete Messages");
  gtk_widget_set_name (undelete, "undelete");
  gtk_widget_ref (undelete);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "undelete", undelete,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (undelete);
  gtk_box_pack_start (GTK_BOX (hbox25), undelete, TRUE, TRUE, 0);

  compact = gtk_button_new_with_label ("Compact Folders Now");
  gtk_widget_set_name (compact, "compact");
  gtk_widget_ref (compact);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "compact", compact,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (compact);
  gtk_box_pack_start (GTK_BOX (hbox25), compact, TRUE, TRUE, 0);

  label31 = gtk_label_new ("Miscellaneous");
  gtk_widget_set_name (label31, "label31");
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
#ifdef WANTLDAP
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 5), label31);
#else
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 4), label31);
#endif

#if 0 /* trey */

  fonts_frame = gtk_frame_new ("Font Settings");
  gtk_widget_set_name (fonts_frame, "fonts_frame");
  gtk_widget_ref (fonts_frame);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "fonts_frame",
		fonts_frame, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fonts_frame);
  gtk_container_add (GTK_CONTAINER (notebook1), fonts_frame);
  gtk_container_set_border_width (GTK_CONTAINER (fonts_frame), 2);

  fonts_label = gtk_label_new ("Fonts");
  gtk_widget_set_name (fonts_label, "fonts_label");
  gtk_widget_ref (fonts_label);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "fonts_label",
			fonts_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fonts_label);
#ifdef WANTLDAP
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
	gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 6), fonts_label);
#else
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
	gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 5), fonts_label);
#endif

  colors_frame = gtk_frame_new ("Color Settings");
  gtk_widget_set_name (colors_frame, "colors_frame");
  gtk_widget_ref (colors_frame);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "colors_frame",
                colors_frame, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (colors_frame);
  gtk_container_add (GTK_CONTAINER (notebook1), colors_frame);
  gtk_container_set_border_width (GTK_CONTAINER (colors_frame), 2);
 
  colors_label = gtk_label_new ("Colors");
  gtk_widget_set_name (colors_label, "colors_label");
  gtk_widget_ref (colors_label);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "colors_label",
                        colors_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (colors_label);
#ifdef WANTLDAP
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
        gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 7), colors_label);
#else
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
        gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 6), colors_label);
#endif


#endif

  dialog_action_area1 = GTK_DIALOG (preference_dialog)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (preference_dialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox8, "hbox8");
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox8, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label ("Ok");
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox8), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (preference_dialog), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox8), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  gtk_object_set_data (GTK_OBJECT (preference_dialog), "tooltips", tooltips);

  return preference_dialog;
}

GtkWidget *create_preference_dialog (void) {
	GtkWidget *widget=create_preference_dialog2 ();
	gtk_signal_connect (ob (widget, "server_clist"), "select_row", 
	                    sf (prefs_server_selected), NULL);
	gtk_signal_connect (ob (widget, "server_clist"), "unselect_row",
	                    sf (prefs_server_unselected), NULL);
	gtk_signal_connect (ob (widget, "server_clist"), "button_press_event", 
	                    sf (prefs_server_bpe), NULL);
	gtk_signal_connect (ob (widget, "preference_dialog"), "delete_event", 
	                    sf (prefs_hide), NULL);
	gtk_signal_connect (ob (widget, "ok_button"), "clicked", 
	                    sf (prefs_hide), NULL);
	gtk_signal_connect (ob (widget, "cancel_button"), "clicked", 
	                    sf (prefs_hide), NULL);
	gtk_signal_connect (ob (widget, "pop3"), "activate",
	                    sf (prefs_pop3_new), NULL);
	gtk_signal_connect (ob (widget, "imap"), "activate",
			sf (prefs_imap_new), NULL);

	gtk_signal_connect (ob (widget, "insert_autosig"), "clicked",
			sf (insert_autosig_callback), NULL);

	gtk_signal_connect (ob (widget, "edit_server_button"), "clicked",
	                    sf (prefs_edit_account), NULL);
	gtk_signal_connect (ob (widget, "delete_server_button"), "clicked", 
	                    sf (prefs_delete_account), NULL);

	gtk_signal_connect (ob (widget, "mime_clist"), "select_row",
	                    sf (mime_types_select_row), NULL);
	gtk_signal_connect (ob (widget, "mime_clist"), "unselect_row",
	                    sf (mime_types_unselect_row), NULL);
	gtk_signal_connect (ob (widget, "add_type"), "clicked",
	                    sf (mime_types_add_type), NULL);
	gtk_signal_connect (ob (widget, "edit_type"), "clicked",
	                    sf (mime_types_edit_type), NULL);
	gtk_signal_connect (ob (widget, "delete_type"), "clicked",
	                    sf (mime_types_delete_type), NULL);

	gtk_signal_connect (ob (widget, "rule_clist"), "select_row",
											sf (filter_rules_select_rule), NULL);
	gtk_signal_connect (ob (widget, "rule_clist"), "unselect_row",
											sf (filter_rules_unselect_rule), NULL);
	gtk_signal_connect (ob (widget, "add_rule"), "clicked",
											sf (filter_rules_add_rule), NULL);
	gtk_signal_connect (ob (widget, "edit_rule"), "clicked",
											sf (filter_rules_edit_rule), NULL);
	gtk_signal_connect (ob (widget, "delete_rule"), "clicked",
											sf (filter_rules_delete_rule), NULL);
	gtk_signal_connect (ob (widget, "header_none"), "toggled",
	                    sf (header_none_selected), NULL);

	gtk_signal_connect (ob (widget, "header_some"), "toggled",
	                    sf (header_some_selected), NULL);
	gtk_signal_connect (ob (widget, "header_all"), "toggled",
	                    sf (header_all_selected), NULL);

	gtk_signal_connect (ob (widget, "reply_none"), "toggled",
	                    sf (reply_none_selected), NULL);
	
	gtk_signal_connect (ob (widget, "reply_quoted"), "toggled",
	                    sf (reply_quoted_selected), NULL);
	gtk_signal_connect (ob (widget, "reply_attach"), "toggled",
	                    sf (reply_attached_selected), NULL);										
	gtk_signal_connect (ob (widget, "undelete"), "clicked",
	                    sf (undelete_messages), NULL);
	gtk_signal_connect (ob (widget, "compact"), "clicked",
	                    sf (compact_folders), NULL);											
	gtk_signal_connect (ob (widget, "filter_up"), "clicked",
	                    sf (filter_rules_move_up), NULL);
	gtk_signal_connect (ob (widget, "filter_down"), "clicked",
	                    sf (filter_rules_move_down), NULL);
	gtk_signal_connect (ob (widget, "hide_status"), "toggled",
	                    sf (preferences_hide_status_toggled), NULL);
	clip_handle_editable (lw (widget, "name_entry"));
	clip_handle_editable (lw (widget, "reply_entry"));
	clip_handle_editable (lw (widget, "org_entry"));
	clip_handle_editable (lw (widget, "email_addy_entry"));
	return widget;
}


GtkWidget *create_pop3_server (int thetype) {
  GtkWidget *pop3_server;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *frame1;
  GtkWidget *table1;
  GtkWidget *hbox2;
  GtkWidget *label9;
  GtkObject *pop3_port_adj;
  GtkWidget *pop3_port;
  GtkWidget *label10;
  GtkObject *smtp_port_adj;
  GtkWidget *smtp_port;
  GtkWidget *label3;
  GtkWidget *label5;
  GtkWidget *label4;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *account_name;
  GtkWidget *pop3_host;
  GtkWidget *pop3_login;
  GtkWidget *password;
  GtkWidget *smtp_host;
  GtkWidget *smtp_login;
  GtkWidget *label1;
  GtkWidget *frame4;
  GtkWidget *table2;
  GtkWidget *your_name;
  GtkWidget *email_addy;
  GtkWidget *reply_to;
  GtkWidget *org;
  GtkWidget *label16;
  GtkWidget *label15;
  GtkWidget *label17;
  GtkWidget *label18;
  GtkWidget *frame5;
  GtkWidget *label19;
  GtkWidget *label2;
  GtkWidget *frame6;
  GtkWidget *vbox5;
  GtkWidget *hbox26;
  GtkWidget *hbox27;
  GtkWidget *save_password;
  GtkWidget *hbox28;
  GtkWidget *delete_mail;
  GtkWidget *hbox29;
  GtkWidget *hbox30;
  GtkWidget *check_mail;
  GtkObject *check_mail_duration_adj;
  GtkWidget *check_mail_duration;
  GtkWidget *hbox31;
  GtkWidget *label52;
  GtkWidget *combo8;
  GtkWidget *store_mail_in;
  GtkWidget *hbox32;
  GtkWidget *check_with_others;
  GtkWidget *ff_box, *ff_button;
#ifdef WANTSSL
  GtkWidget *ssl_box, *ssl_button, *ssl_label;
  GtkWidget *cert_box, *cert_button, *cert_label;
#endif
  GtkWidget *label11;
  GtkWidget *frame7;
  GtkWidget *table3;
  GtkWidget *scrolledwindow1;
  GtkWidget *signature;
  GtkWidget *use_sig;
  GtkWidget *use_unix_sig;
  GtkWidget *label14;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  pop3_server = gtk_dialog_new ();
  gtk_widget_set_name (pop3_server, "pop3_server");
  gtk_object_set_data (GTK_OBJECT (pop3_server), "pop3_server", pop3_server);

  switch( thetype ) {
  case POP3:
    gtk_window_set_title (GTK_WINDOW (pop3_server), _("POP3 Server info"));
    break ;

  case IMAP:
    gtk_window_set_title (GTK_WINDOW (pop3_server), _("IMAP Server info"));
    break ;
  }
  gtk_window_set_modal (GTK_WINDOW (pop3_server), TRUE);
  gtk_window_set_policy (GTK_WINDOW (pop3_server), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (pop3_server)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (pop3_server), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_set_name (notebook1, "notebook1");
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebook1, TRUE, TRUE, 0);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (notebook1), frame1);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  table1 = gtk_table_new (7, 2, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame1), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 2);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_table_attach (GTK_TABLE (table1), hbox2, 0, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  switch( thetype ) {
  case POP3:
    label9 = gtk_label_new (_("POP3 Port"));
    break ;

  case IMAP:
    label9 = gtk_label_new (_("IMAP Port"));
    break ;

  default:
    label9 = gtk_label_new (_("Unknown Port"));
    break ;
  }

  gtk_widget_set_name (label9, "label9");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox2), label9, TRUE, TRUE, 0);
  right_align (label9);

  pop3_port_adj = gtk_adjustment_new (110, 1, 65535, 1, 10, 10);
  pop3_port = gtk_spin_button_new (GTK_ADJUSTMENT (pop3_port_adj), 1, 0);
  gtk_widget_set_name (pop3_port, "pop3_port");
  gtk_widget_ref (pop3_port);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "pop3_port", pop3_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pop3_port);
  gtk_box_pack_start (GTK_BOX (hbox2), pop3_port, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, pop3_port, _("The port of your incoming mail server.  Best to leave this default unless you are sure that the default is not correct."), NULL);

  label10 = gtk_label_new (_("SMTP Port"));
  gtk_widget_set_name (label10, "label10");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (hbox2), label10, TRUE, TRUE, 0);
  right_align (label10);

  smtp_port_adj = gtk_adjustment_new (25, 1, 65535, 1, 10, 10);
  smtp_port = gtk_spin_button_new (GTK_ADJUSTMENT (smtp_port_adj), 1, 0);
  gtk_widget_set_name (smtp_port, "smtp_port");
  gtk_widget_ref (smtp_port);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "smtp_port", smtp_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (smtp_port);
  gtk_box_pack_start (GTK_BOX (hbox2), smtp_port, TRUE, TRUE, 0);
  gtk_tooltips_set_tip (tooltips, smtp_port, _("Port of your outgoing mail server.  Also best to leave default unless your are sure it is not correct."), NULL);

  label3 = gtk_label_new (_("Account Name"));
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table1), label3, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 2, 0);
  right_align (label3);

  switch( thetype ) {
  case POP3:
	  label5 = gtk_label_new (_("POP3 Login"));
    break ;

  case IMAP:
	  label5 = gtk_label_new (_("IMAP Login"));
    break ;

  default:
    label5 = gtk_label_new (_("Login"));
    break ;
  }

  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 2, 0);
  right_align (label5);

  switch( thetype ) {
  case POP3:
  	label4 = gtk_label_new (_("POP3 Host"));
    break ;

  case IMAP:
  	label4 = gtk_label_new (_("IMAP Host"));
    break ;

  default:
    label4 = gtk_label_new (_("Host"));
    break ;
  }

  gtk_widget_set_name (label4, "label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 2, 0);
  right_align (label4);

  label6 = gtk_label_new (_("Password"));
  gtk_widget_set_name (label6, "label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table1), label6, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 2, 0);
  right_align (label6);

  label7 = gtk_label_new (_("SMTP Host"));
  gtk_widget_set_name (label7, "label7");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table1), label7, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 2, 0);
  right_align (label7);

  label8 = gtk_label_new (_("SMTP Login"));
  gtk_widget_set_name (label8, "label8");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table1), label8, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 2, 0);
  right_align (label8);

  account_name = gtk_entry_new ();
  gtk_widget_set_name (account_name, "account_name");
  gtk_widget_ref (account_name);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "account_name", account_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (account_name);
  gtk_table_attach (GTK_TABLE (table1), account_name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, account_name, _("This is a label to be visually associated with this account."), NULL);

  pop3_host = gtk_entry_new ();
  gtk_widget_set_name (pop3_host, "pop3_host");
  gtk_widget_ref (pop3_host);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "pop3_host", pop3_host,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pop3_host);
  gtk_table_attach (GTK_TABLE (table1), pop3_host, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, pop3_host, _("The hostname or IP of your incoming mail server. Contact your IT department if unsure."), NULL);

  pop3_login = gtk_entry_new ();
  gtk_widget_set_name (pop3_login, "pop3_login");
  gtk_widget_ref (pop3_login);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "pop3_login", pop3_login,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pop3_login);
  gtk_table_attach (GTK_TABLE (table1), pop3_login, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, pop3_login, _("Your login name.  This is usually the first part of your email address, but it may not be.  If unsure, please contact your system adminstrator"), NULL);

  password = gtk_entry_new ();
  gtk_widget_set_name (password, "password");
  gtk_widget_ref (password);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "password", password,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (password);
  gtk_table_attach (GTK_TABLE (table1), password, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, password, _("Enter your password for this account here."), NULL);
	gtk_entry_set_visibility (GTK_ENTRY (password), FALSE);

  smtp_host = gtk_entry_new ();
  gtk_widget_set_name (smtp_host, "smtp_host");
  gtk_widget_ref (smtp_host);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "smtp_host", smtp_host,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (smtp_host);
  gtk_table_attach (GTK_TABLE (table1), smtp_host, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, smtp_host, _("The hostname or IP of your outgoing mail server.  If you are unsure, please contact your IT Department."), NULL);

  smtp_login = gtk_entry_new ();
  gtk_widget_set_name (smtp_login, "smtp_login");
  gtk_widget_ref (smtp_login);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "smtp_login", smtp_login,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (smtp_login);
  gtk_table_attach (GTK_TABLE (table1), smtp_login, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, smtp_login, _("The login name for the outgoing mail server.  This may not be required, but it is a good idea to enter it in anyway.  Often, it will be the same as your POP3 Login."), NULL);

  label1 = gtk_label_new (_("Server Settings"));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label1);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame4, "frame4");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_container_add (GTK_CONTAINER (notebook1), frame4);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 2);

  table2 = gtk_table_new (5, 2, FALSE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame4), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 2);

  your_name = gtk_entry_new ();
  gtk_widget_set_name (your_name, "your_name");
  gtk_widget_ref (your_name);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "your_name", your_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (your_name);
  gtk_table_attach (GTK_TABLE (table2), your_name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, your_name, _("Enter your name or prefered alias here."), NULL);

  email_addy = gtk_entry_new ();
  gtk_widget_set_name (email_addy, "email_addy");
  gtk_widget_ref (email_addy);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "email_addy", email_addy,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (email_addy);
  gtk_table_attach (GTK_TABLE (table2), email_addy, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, email_addy, _("Enter the email address you want emails sent through this account to show up as from."), NULL);

  reply_to = gtk_entry_new ();
  gtk_widget_set_name (reply_to, "reply_to");
  gtk_widget_ref (reply_to);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "reply_to", reply_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_to);
  gtk_table_attach (GTK_TABLE (table2), reply_to, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, reply_to, _("Enter this account only if your reply-to address is different from your email address."), NULL);

  org = gtk_entry_new ();
  gtk_widget_set_name (org, "org");
  gtk_widget_ref (org);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "org", org,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (org);
  gtk_table_attach (GTK_TABLE (table2), org, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, org, _("Your organization"), NULL);

  label16 = gtk_label_new (_("Email Address"));
  gtk_widget_set_name (label16, "label16");
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_table_attach (GTK_TABLE (table2), label16, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label16);

  label15 = gtk_label_new (_("Your Name"));
  gtk_widget_set_name (label15, "label15");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_table_attach (GTK_TABLE (table2), label15, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label15);

  label17 = gtk_label_new (_("Reply To Address"));
  gtk_widget_set_name (label17, "label17");
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_table_attach (GTK_TABLE (table2), label17, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label17);

  label18 = gtk_label_new (_("Organization"));
  gtk_widget_set_name (label18, "label18");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_table_attach (GTK_TABLE (table2), label18, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  right_align (label18);

  frame5 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame5, "frame5");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_table_attach (GTK_TABLE (table2), frame5, 0, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 2);
  //label19 = gtk_label_new (_("These are per-account settings which override your\nglobally define settings.  If you wish to use your \nglobal settings, you may leave these blank, or\nyou may optionally fill in which global \nvalues you want to override.  "));
  label19 = gtk_label_new ("These are per-account settings which override your\nglobally define settings.  If you wish to use your\nglobal settings, you may leave these blank, or you\nmay optionally fill in which global values you\nwant to override.");
  gtk_widget_set_name (label19, "label19");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_container_add (GTK_CONTAINER (frame5), label19);
  gtk_misc_set_padding (GTK_MISC (label19), 2, 2);
  gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_FILL);


  label2 = gtk_label_new (_("Identity"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label2);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame6, "frame6");
  gtk_widget_ref (frame6);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame6);
  gtk_container_add (GTK_CONTAINER (notebook1), frame6);
  gtk_container_set_border_width (GTK_CONTAINER (frame6), 2);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (frame6), vbox5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 2);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox26, "hbox26");
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox26, FALSE, TRUE, 0);

  hbox27 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox27, "hbox27");
  gtk_widget_ref (hbox27);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox27", hbox27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox27);
  gtk_box_pack_start (GTK_BOX (hbox26), hbox27, TRUE, TRUE, 0);

  save_password = gtk_check_button_new_with_label (_("Save Password To Disk"));
  gtk_widget_set_name (save_password, "save_password");
  gtk_widget_ref (save_password);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "save_password", save_password,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_password);
  gtk_box_pack_start (GTK_BOX (hbox27), save_password, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (save_password), TRUE);

  hbox28 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox28, "hbox28");
  gtk_widget_ref (hbox28);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox28", hbox28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox28);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox28, FALSE, FALSE, 0);

  delete_mail = gtk_check_button_new_with_label (_("Delete all mail from server"));
  gtk_widget_set_name (delete_mail, "delete_mail");
  gtk_widget_ref (delete_mail);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "delete_mail", delete_mail,
                            (GtkDestroyNotify) gtk_widget_unref);
if (thetype != IMAP)  gtk_widget_show (delete_mail);
  gtk_box_pack_start (GTK_BOX (hbox28), delete_mail, FALSE, FALSE, 0);

  hbox29 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox29, "hbox29");
  gtk_widget_ref (hbox29);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox29", hbox29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox29);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox29, FALSE, FALSE, 0);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox30, "hbox30");
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_box_pack_start (GTK_BOX (hbox29), hbox30, TRUE, TRUE, 0);

  check_mail = gtk_check_button_new_with_label (_("Check for mail every"));
  gtk_widget_set_name (check_mail, "check_mail");
  gtk_widget_ref (check_mail);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "check_mail", check_mail,
                            (GtkDestroyNotify) gtk_widget_unref);
if (thetype != IMAP) gtk_widget_show (check_mail);
  gtk_box_pack_start (GTK_BOX (hbox30), check_mail, FALSE, FALSE, 0);

  check_mail_duration_adj = gtk_adjustment_new (15, 1, 65535, 1, 10, 10);
  check_mail_duration = gtk_spin_button_new (GTK_ADJUSTMENT (check_mail_duration_adj), 1, 0);
  gtk_widget_set_name (check_mail_duration, "check_mail_duration");
  gtk_widget_ref (check_mail_duration);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "check_mail_duration", check_mail_duration,
                            (GtkDestroyNotify) gtk_widget_unref);
if (thetype != IMAP)  gtk_widget_show (check_mail_duration);
  gtk_box_pack_start (GTK_BOX (hbox29), check_mail_duration, TRUE, TRUE, 0);

  hbox31 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox31, "hbox31");
  gtk_widget_ref (hbox31);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox31", hbox31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox31);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox31, FALSE, FALSE, 0);

  label52 = gtk_label_new (_("Store incoming mail in"));
  gtk_widget_set_name (label52, "label52");
  gtk_widget_ref (label52);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label52", label52,
                            (GtkDestroyNotify) gtk_widget_unref);
  if (thetype != IMAP) gtk_widget_show (label52);
  gtk_box_pack_start (GTK_BOX (hbox31), label52, FALSE, FALSE, 0);

  combo8 = gtk_combo_new ();
  gtk_widget_set_name (combo8, "combo8");
  gtk_widget_ref (combo8);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "combo8", combo8,
                            (GtkDestroyNotify) gtk_widget_unref);
  if (thetype != IMAP) gtk_widget_show (combo8);
  gtk_box_pack_start (GTK_BOX (hbox31), combo8, TRUE, TRUE, 0);

  store_mail_in = GTK_COMBO (combo8)->entry;
  gtk_widget_set_name (store_mail_in, "store_mail_in");
  gtk_widget_ref (store_mail_in);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "store_mail_in", store_mail_in,
                            (GtkDestroyNotify) gtk_widget_unref);
  if (thetype != IMAP) gtk_widget_show (store_mail_in);

  hbox32 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox32, "hbox32");
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox32, FALSE, FALSE, 0);

  check_with_others = gtk_check_button_new_with_label (_("Check for mail when doing a `Get Messages'"));
  gtk_widget_set_name (check_with_others, "check_with_others");
  gtk_widget_ref (check_with_others);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "check_with_others", check_with_others,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (check_with_others);
  gtk_box_pack_start (GTK_BOX (hbox32), check_with_others, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (check_with_others), TRUE);

  ff_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (ff_box, "ff_box");
  gtk_widget_ref (ff_box);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "ff_box", ff_box,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ff_box);
  gtk_box_pack_start (GTK_BOX (vbox5), ff_box, FALSE, FALSE, 0);

  ff_button = gtk_check_button_new_with_label (_("Force fetch of all messages next time"));
  gtk_widget_set_name (ff_button, "ff_button");
  gtk_widget_ref (ff_button);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "ff_button", ff_button,
                            (GtkDestroyNotify) gtk_widget_unref);
#if 0
  if (thetype != IMAP) gtk_widget_show (ff_button);
#endif
  gtk_box_pack_start (GTK_BOX (ff_box), ff_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (ff_button), FALSE);

#ifdef WANTSSL
  ssl_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (ssl_box, "ssl_box");
  gtk_widget_ref (ssl_box);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "ssl_box", ssl_box,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ssl_box);
  gtk_box_pack_start (GTK_BOX (vbox5), ssl_box, FALSE, FALSE, 0);

  ssl_button = gtk_check_button_new_with_label (_("SSL connection"));
  gtk_widget_set_name (ssl_button, "ssl_button");
  gtk_widget_ref (ssl_button);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "ssl_button", ssl_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ssl_button);
  gtk_box_pack_start (GTK_BOX (ssl_box), ssl_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (ssl_button), FALSE);
  gtk_signal_connect (GTK_OBJECT (ssl_button), "toggled",
	GTK_SIGNAL_FUNC (ssl_toggled), (gpointer)thetype);

  cert_box = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (cert_box, "cert_box");
  gtk_widget_ref (cert_box);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "cert_box", cert_box,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cert_box);
  gtk_box_pack_start (GTK_BOX (vbox5), cert_box, FALSE, FALSE, 0);

  cert_button = gtk_check_button_new_with_label (_("Verify server certificate"));
  gtk_widget_set_name (cert_button, "cert_button");
  gtk_widget_ref (cert_button);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "cert_button", cert_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cert_button);
  gtk_box_pack_start (GTK_BOX (cert_box), cert_button, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (cert_button), FALSE);
#endif

  label11 = gtk_label_new (_("Mail Options"));
  gtk_widget_set_name (label11, "label11");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label11);

  frame7 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame7, "frame7");
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame7);
  gtk_container_add (GTK_CONTAINER (notebook1), frame7);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  table3 = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (table3, "table3");
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_container_add (GTK_CONTAINER (frame7), table3);
  gtk_container_set_border_width (GTK_CONTAINER (table3), 2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_table_attach (GTK_TABLE (table3), scrolledwindow1, 0, 1, 1, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  signature = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (signature, "signature");
  gtk_widget_ref (signature);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "signature", signature,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (signature);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), signature);
  gtk_tooltips_set_tip (tooltips, signature, _("Enter a signature here to use when sending email out through this account.  This signature, if defined will override your global signature."), NULL);
  gtk_text_set_editable (GTK_TEXT (signature), TRUE);

  use_sig = gtk_check_button_new_with_label (_("Use this signature instead of global sig"));
  gtk_widget_set_name (use_sig, "use_sig");
  gtk_widget_ref (use_sig);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "use_sig", use_sig,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (use_sig);
  gtk_table_attach (GTK_TABLE (table3), use_sig, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 2, 0);

  use_unix_sig = gtk_toggle_button_new_with_label (_("Use ~/.sig"));
  gtk_widget_set_name (use_unix_sig, "use_unix_sig");
  gtk_widget_ref (use_unix_sig);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "use_unix_sig", use_unix_sig,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (use_unix_sig);
  gtk_table_attach (GTK_TABLE (table3), use_unix_sig, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, use_unix_sig, _("Load your .sig file on client startup and use that as your signature."), NULL);

/*  insert_file = gtk_button_new_with_label (_("Insert File..."));
  gtk_widget_set_name (insert_file, "insert_file");
  gtk_widget_ref (insert_file);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "insert_file", insert_file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (insert_file);
  gtk_table_attach (GTK_TABLE (table3), insert_file, 1, 2, 1, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_tooltips_set_tip (tooltips, insert_file, _("*** WARNING *** FUNCTION NOT IMPLEMENTED"), NULL);*/

  label14 = gtk_label_new (_("Signature"));
  gtk_widget_set_name (label14, "label14");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 3), label14);

  dialog_action_area1 = GTK_DIALOG (pop3_server)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (pop3_server), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (hbox1), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (pop3_server), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (hbox1), cancel_button, TRUE, TRUE, 0);

  gtk_object_set_data (GTK_OBJECT (pop3_server), "tooltips", tooltips);

  return pop3_server;
}

GtkWidget* prefs_server_window (PopAccount *ok_data, PopAccount *cancel_data) {
	GtkWidget *widget=NULL;
	GList *seek=folder_create_storeable_glist ();
	g_return_val_if_fail (ok_data != NULL, NULL);
	{
		widget=create_pop3_server(ok_data->type);
		gtk_combo_set_popdown_strings (GTK_COMBO (lw (widget, "combo8")), seek);
		g_list_free (seek);
		st (widget, "account_name", ok_data->name);	st (widget, "pop3_host", ok_data->phost);
		st (widget, "pop3_login", ok_data->puser); st (widget, "password", ok_data->ppasswd);
		st (widget, "smtp_host", ok_data->shost);	st (widget, "smtp_login", ok_data->suser);
		st (widget, "your_name", ok_data->real_name);	st (widget, "email_addy", ok_data->emailaddr);
		st (widget, "reply_to", ok_data->replyaddr); st (widget, "org", ok_data->organization);
		st (widget, "store_mail_in", ok_data->folder);
		sv (widget, "pop3_port", ok_data->pport); sv (widget, "smtp_port", ok_data->sport);
		st (widget, "signature", ok_data->signature);
		if (ok_data->flags & REMBER_PASSWORD_ALWAYS) {
			tba (widget, "save_password");
		} else {
			if ((ok_data->name) && strlen (ok_data->name)) {
				tbn (widget, "save_password");
			}
		}
		if (ok_data->flags & DELETEFROMSERVER) tba (widget, "delete_mail");
		if (ok_data->flags & CHECK_WITH_ALL) {
			tba (widget, "check_with_others"); 
		} else {
			if ((ok_data->name) && strlen (ok_data->name)) {
				tbn (widget, "check_with_others"); 
			}
		}
		if (ok_data->flags & FORCE_FETCH) {
			tba (widget, "ff_button");
		} else {
			tbn (widget, "ff_button");
		}
#ifdef WANTSSL
                if (ok_data->flags & SSL_CONN) {
                        tba (widget, "ssl_button");
                } else {
                        tbn (widget, "ssl_button");
                }
                if (ok_data->flags & SSL_VERIFY_CERT) {
                        tba (widget, "cert_button");
                } else {
                        tbn (widget, "cert_button");
                }
#endif
		if (ok_data->flags & USE_THIS_SIG) tba (widget, "use_sig");
		if (ok_data->flags & USE_THIS_UNIX_SIG) tba (widget, "use_unix_sig");
		if (ok_data->timeout != 0) {
			tba (widget, "check_mail");
			sv (widget, "check_mail_duration", ok_data->timeout);
		} else {
			tbn (widget, "check_mail");
		}
		clip_handle_editable (lw2 ("account_name"));
		clip_handle_editable (lw2 ("pop3_host"));
		clip_handle_editable (lw2 ("pop3_login"));
		clip_handle_editable (lw2 ("password"));
		clip_handle_editable (lw2 ("smtp_host"));
		clip_handle_editable (lw2 ("smtp_login"));
		clip_handle_editable (lw2 ("your_name"));
		clip_handle_editable (lw2 ("email_addy"));
		clip_handle_editable (lw2 ("reply_to"));
		clip_handle_editable (lw2 ("org"));
		clip_handle_editable (lw2 ("signature"));	
		gtk_signal_connect (ob (widget, "ok_button"), "clicked",
		                    sf (prefs_accept_pop3), ok_data);
		gtk_signal_connect (ob (widget, "cancel_button"), "clicked",
		                    sf (prefs_cancel_pop3), cancel_data);
		/* we have to connect this signal to a boolean return,
		 * false let's the window close, true keeps it open...
		 * if you return false, then the "destroy" signal is called:
		 */
#if 0
		gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
				GTK_SIGNAL_FUNC (gtk_false), NULL);
		/* and this is where we link the cancel callback */
		gtk_signal_connect (GTK_OBJECT (widget), "destroy",
			GTK_SIGNAL_FUNC (prefs_cancel_pop3), cancel_data);
#else
//trey
		gtk_signal_connect (GTK_OBJECT (widget), "delete_event",
			GTK_SIGNAL_FUNC (gtk_true), NULL);
#endif
		gtk_widget_show (widget);
	}
	return widget;
}

GtkWidget* create_mime_type_window (void) {
  GtkWidget *mime_type_window;
  GtkWidget *dialog_vbox3;
  GtkWidget *frame9;
  GtkWidget *table3;
  GtkWidget *label40;
  GtkWidget *mime_type;
  GtkWidget *drawingarea1;
  GtkWidget *drawingarea2;
  GtkWidget *label41;
  GtkWidget *label42;
  GtkWidget *extensions;
  GtkWidget *hbox15;
  GtkWidget *handler;
  GtkWidget *button4;
  GtkWidget *hbox19;
  GSList *mime_renderer_group = NULL;
  GtkWidget *ri_radio;
  GtkWidget *label48;
  GtkWidget *hbox21;
  GtkWidget *rp_radio;
  GtkWidget *label52;
  GtkWidget *hbox20;
  GtkWidget *re_radio;
  GtkWidget *label50;
  GtkWidget *hbox22;
  GtkWidget *rs_radio;
  GtkWidget *label51;
  GtkWidget *drawingarea3;
  GtkWidget *drawingarea4;
  GtkWidget *dialog_action_area3;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  mime_type_window = gtk_dialog_new ();
  gtk_widget_set_name (mime_type_window, "mime_type_window");
  gtk_object_set_data (GTK_OBJECT (mime_type_window), "mime_type_window", mime_type_window);
  gtk_window_set_title (GTK_WINDOW (mime_type_window), _("Add/Edit MIME Type"));
  gtk_window_set_modal (GTK_WINDOW (mime_type_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (mime_type_window), TRUE, TRUE, TRUE);

  dialog_vbox3 = GTK_DIALOG (mime_type_window)->vbox;
  gtk_widget_set_name (dialog_vbox3, "dialog_vbox3");
  gtk_object_set_data (GTK_OBJECT (mime_type_window), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  frame9 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame9, "frame9");
  gtk_widget_ref (frame9);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "frame9", frame9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame9);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), frame9, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame9), 2);

  table3 = gtk_table_new (7, 2, FALSE);
  gtk_widget_set_name (table3, "table3");
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_container_add (GTK_CONTAINER (frame9), table3);
  gtk_container_set_border_width (GTK_CONTAINER (table3), 2);

  label40 = gtk_label_new (_("MIME Type"));
  gtk_widget_set_name (label40, "label40");
  gtk_widget_ref (label40);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label40", label40,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label40);
  gtk_table_attach (GTK_TABLE (table3), label40, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 2, 0);

  mime_type = gtk_entry_new ();
  gtk_widget_set_name (mime_type, "mime_type");
  gtk_widget_ref (mime_type);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "mime_type", mime_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mime_type);
  gtk_table_attach (GTK_TABLE (table3), mime_type, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea1, "drawingarea1");
  gtk_widget_ref (drawingarea1);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "drawingarea1", drawingarea1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea1);
  gtk_table_attach (GTK_TABLE (table3), drawingarea1, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  drawingarea2 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea2, "drawingarea2");
  gtk_widget_ref (drawingarea2);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "drawingarea2", drawingarea2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea2);
  gtk_table_attach (GTK_TABLE (table3), drawingarea2, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  label41 = gtk_label_new (_("External Program"));
  gtk_widget_set_name (label41, "label41");
  gtk_widget_ref (label41);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label41", label41,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label41);
  gtk_table_attach (GTK_TABLE (table3), label41, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 2, 0);

  label42 = gtk_label_new (_("Extensions"));
  gtk_widget_set_name (label42, "label42");
  gtk_widget_ref (label42);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label42", label42,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label42);
  gtk_table_attach (GTK_TABLE (table3), label42, 0, 1, 6, 7,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 2, 0);

  extensions = gtk_entry_new ();
  gtk_widget_set_name (extensions, "extensions");
  gtk_widget_ref (extensions);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "extensions", extensions,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (extensions);
  gtk_table_attach (GTK_TABLE (table3), extensions, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 0);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox15, "hbox15");
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox15);
  gtk_table_attach (GTK_TABLE (table3), hbox15, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  handler = gtk_entry_new ();
  gtk_widget_set_name (handler, "handler");
  gtk_widget_ref (handler);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "handler", handler,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handler);
  gtk_box_pack_start (GTK_BOX (hbox15), handler, TRUE, TRUE, 0);

  button4 = gtk_button_new_with_label (_("Browse"));
  gtk_widget_set_name (button4, "button4");
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  gtk_box_pack_start (GTK_BOX (hbox15), button4, FALSE, FALSE, 0);

  hbox19 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox19, "hbox19");
  gtk_widget_ref (hbox19);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "hbox19", hbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox19);
  gtk_table_attach (GTK_TABLE (table3), hbox19, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  ri_radio = gtk_radio_button_new_with_label (mime_renderer_group, "");
  mime_renderer_group = gtk_radio_button_group (GTK_RADIO_BUTTON (ri_radio));
  gtk_widget_set_name (ri_radio, "ri_radio");
  gtk_widget_ref (ri_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "ri_radio", ri_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ri_radio);
  gtk_box_pack_start (GTK_BOX (hbox19), ri_radio, FALSE, FALSE, 0);

  label48 = gtk_label_new (_("Internal"));
  gtk_widget_set_name (label48, "label48");
  gtk_widget_ref (label48);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label48", label48,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label48);
  gtk_box_pack_start (GTK_BOX (hbox19), label48, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label48), 3, 0);

  hbox21 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox21, "hbox21");
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_table_attach (GTK_TABLE (table3), hbox21, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  rp_radio = gtk_radio_button_new_with_label (mime_renderer_group, "");
  mime_renderer_group = gtk_radio_button_group (GTK_RADIO_BUTTON (rp_radio));
  gtk_widget_set_name (rp_radio, "rp_radio");
  gtk_widget_ref (rp_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "rp_radio", rp_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rp_radio);
  gtk_box_pack_start (GTK_BOX (hbox21), rp_radio, FALSE, FALSE, 0);

  label52 = gtk_label_new (_("Prompt User"));
  gtk_widget_set_name (label52, "label52");
  gtk_widget_ref (label52);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label52", label52,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label52);
  gtk_box_pack_start (GTK_BOX (hbox21), label52, FALSE, FALSE, 0);

  hbox20 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox20, "hbox20");
  gtk_widget_ref (hbox20);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "hbox20", hbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox20);
  gtk_table_attach (GTK_TABLE (table3), hbox20, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  re_radio = gtk_radio_button_new_with_label (mime_renderer_group, "");
  mime_renderer_group = gtk_radio_button_group (GTK_RADIO_BUTTON (re_radio));
  gtk_widget_set_name (re_radio, "re_radio");
  gtk_widget_ref (re_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "re_radio", re_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (re_radio);
  gtk_box_pack_start (GTK_BOX (hbox20), re_radio, FALSE, FALSE, 0);

  label50 = gtk_label_new (_("External Program"));
  gtk_widget_set_name (label50, "label50");
  gtk_widget_ref (label50);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label50", label50,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label50);
  gtk_box_pack_start (GTK_BOX (hbox20), label50, FALSE, FALSE, 0);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox22, "hbox22");
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox22);
  gtk_table_attach (GTK_TABLE (table3), hbox22, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  rs_radio = gtk_radio_button_new_with_label (mime_renderer_group, "");
  mime_renderer_group = gtk_radio_button_group (GTK_RADIO_BUTTON (rs_radio));
  gtk_widget_set_name (rs_radio, "rs_radio");
  gtk_widget_ref (rs_radio);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "rs_radio", rs_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rs_radio);
  gtk_box_pack_start (GTK_BOX (hbox22), rs_radio, FALSE, FALSE, 0);

  label51 = gtk_label_new (_("Save To Disk"));
  gtk_widget_set_name (label51, "label51");
  gtk_widget_ref (label51);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "label51", label51,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label51);
  gtk_box_pack_start (GTK_BOX (hbox22), label51, FALSE, FALSE, 0);

  drawingarea3 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea3, "drawingarea3");
  gtk_widget_ref (drawingarea3);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "drawingarea3", drawingarea3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea3);
  gtk_table_attach (GTK_TABLE (table3), drawingarea3, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  drawingarea4 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea4, "drawingarea4");
  gtk_widget_ref (drawingarea4);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "drawingarea4", drawingarea4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea4);
  gtk_table_attach (GTK_TABLE (table3), drawingarea4, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  dialog_action_area3 = GTK_DIALOG (mime_type_window)->action_area;
  gtk_widget_set_name (dialog_action_area3, "dialog_action_area3");
  gtk_object_set_data (GTK_OBJECT (mime_type_window), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (ok_button, "ok_button");
  gtk_widget_ref (ok_button);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "ok_button", ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), ok_button, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (mime_type_window), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), cancel_button, TRUE, TRUE, 0);

  gtk_widget_grab_focus (ok_button);
  gtk_widget_grab_default (ok_button);
  return mime_type_window;
}

GtkAdjustment *adjust=NULL;

int prefs_setup_info () {
	unsigned long ftotal=0, mtotal=0;
	GtkWidget *widget=prefs_get_widget ();
	GtkRange *range;
	GtkProgress *progress;
	Folder *fl;
	float tmp;
	Message *msg;
	char *str;


	if (!GTK_IS_WIDGET (widget)) {
		return TRUE;
	}

#ifdef DMALLOC
	dmalloc_verify( NULL ) ;
#endif
	range=GTK_RANGE (lookup_widget (prefs_get_widget (), "wasted_warning"));
	progress=GTK_PROGRESS (lookup_widget (prefs_get_widget (), "wasted_space"));
	if (!adjust) {
		adjust=GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 100, 0, 0, 0));
		gtk_range_set_adjustment (range, adjust);
		gtk_signal_connect (GTK_OBJECT (adjust), "value_changed",
		                    sf (wasted_value_changed), NULL);
	}
	for (fl=folder_first();fl;fl=fl->next) {
		ftotal+=fl->asize;
		for (msg=fl->msglst;msg;msg=msg->next) {
			mtotal+=msg->size+23;
		}
	}
	str=(char *)calloc (40, sizeof (char));
	snprintf (str, 39, "%lu Bytes (\%%P\%%\%%)", ftotal-mtotal);
	gtk_progress_set_format_string (GTK_PROGRESS (lookup_widget (prefs_get_widget (), "wasted_space")), str);
	free (str);
	adjust->lower=0;
	adjust->upper=110;
	adjust->value=tm_globs->wasted;
	adjust->page_size=10;	
	gtk_adjustment_value_changed (adjust);
	tmp=1-((float)mtotal/(float)ftotal);
#if DEBUG>=3
	if (tmp < 0) {
		printf ("Internal Error with the folders: \n	Total Message sizes are greater than actual folder size!\n");
		printf ("Total Message Size: %lu Total Folder Size: %lu\n", mtotal, ftotal);
	}
	printf( "thresh = %f.\n", tm_globs->wasted/100 ) ;
#endif
	if (tmp <= 1 && tmp >= 0) {
		gtk_progress_set_percentage (progress, tmp);

		/* Check to see if we need to warn about wasted space */
		if( (tm_globs->wasted) && (tmp >= (tm_globs->wasted/100)) ) {
	 	  if (tm_globs->wsflag)
		    insert_warning( _("Wasted message space is exceeding your configured threshold!\n") ) ;
		  tm_globs->wsflag = 0;
		} else {
		  tm_globs->wsflag = 1;
		}
	}
#if DEBUG > 4
	printf ("*****************\n");
	printf ("Total Size: %lu Recorded Size: %lu Wasted Space: %f, thresh hold %f\n", 
	        ftotal, mtotal, 1-((float)mtotal/(float)ftotal), (tm_globs->wasted/100) );
	printf ("*****************\n");
#endif

#ifdef DMALLOC
	dmalloc_verify( NULL ) ;
#endif

	return TRUE ;
}


#ifdef WANTSSL
void
ssl_toggled (GtkWidget *widget, gpointer data)
{
  GtkWidget *port = lookup_widget (widget, "pop3_port");
  int type = (int)data;

  if (GTK_TOGGLE_BUTTON (widget)->active)
    {
      switch( type ) {
      case POP3:
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (port), (float)995);
	break;
      case IMAP:
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (port), (float)993);
	break;
      }
    }
  else
    {
      switch( type ) {
      case POP3:
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (port), (float)110);
	break;
      case IMAP:
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (port), (float)143);
	break;
      }
    }
}


#ifdef WANTLDAP
void
ldapssl_toggled(GtkWidget *widget, gpointer data) {
  GtkWidget *port = lookup_widget (widget, "l_entry_port");

  if (GTK_TOGGLE_BUTTON (widget)->active)
    {
      gtk_spin_button_set_value (GTK_SPIN_BUTTON (port), (float)636);
      tm_globs->ldap_ssl=1;
    } else {
      gtk_spin_button_set_value (GTK_SPIN_BUTTON (port), (float)389);
      tm_globs->ldap_ssl=0;
    }
}
#endif
#endif
