/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: callbacks.h,v 1.4 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _CALLBACKS_H_
#define _CALLBACKS_H_

#include "puma.h"

void puma_die (GtkWidget *, gpointer);
void destroy_ewmd_dialog (GtkWidget *, gpointer);
void drag_data_recieved_on_folder (GtkWidget *, GdkDragContext *,
                                   gint, gint, GtkSelectionData *,
                                   guint, guint);
void destroy_aboutbox (GtkWidget *, gpointer);
void activate_aboutbox (GtkWidget *, gpointer);
void destroy_new_password_dialog (GtkWidget *, gpointer);
void accept_new_password_dialog (GtkWidget *, gpointer);
gint do_something (GtkWidget *, GdkEvent *, gpointer);
void docsource_create (GtkWidget *widget, gpointer data);
void docsource_destroy (GtkWidget *widget, gpointer data);
void message_anti_leak ();
#endif /* _CALLBACKS_H_ */
