/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: file-selector-window.h,v 1.4 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _FILE_SELECTOR_WINDOW_H_
#define _FILE_SELECTOR_WINDOW_H_
#include "puma.h"

char *get_cwd ();
GtkWidget *file_selector_new (char *startdir, char *startname, GtkSignalFunc okfunc, GtkSignalFunc cancelfunc, gpointer data);
void fs_goto_homedir( GtkWidget *widget ) ;
void fs_new_directory_window (GtkWidget *parent);
void fs_rename_window (GtkWidget *widget);
void set_cwd (char *dir);

extern GdkPixmap *open_pix, *close_pix;
extern GdkBitmap *open_mask, *close_mask;

#endif /* _FILE_SELECTOR_WINDOW_H_ */
