/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: filter-callbacks.h,v 1.3 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _FILTER_CALLBACKS_H_
#define _FILTER_CALLBACKS_H_

#include "puma.h"

/*typedef enum WindowType {
	TYPE_ADD,
	TYPE_EDIT
} WindowType;

void filter_rules_add_rule (GtkWidget *widget, gpointer data);
void filter_rules_edit_rule (GtkWidget *widget, gpointer data);
void filter_rules_delete_rule (GtkWidget *widget, gpointer data);

void filter_rules_select_rule (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void filter_rules_unselect_rule (GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void filter_rules_display_rule (FilterRule *rule);

void filter_rules_accept_entry (GtkWidget *widget, gpointer data);
void filter_rules_cancel_entry (GtkWidget *widget, gpointer data);
void filter_rules_destroy_entry (GtkWidget *widget, GdkEvent *event, gpointer data);

void filter_rules_criteria_scw (GtkWidget *widget, gpointer data);
void filter_rules_criteria_bcw (GtkWidget *widget, gpointer data);
void filter_rules_criteria_tca (GtkWidget *widget, gpointer data);
void filter_rules_criteria_ccca (GtkWidget *widget, gpointer data);
void filter_rules_criteria_mg (GtkWidget *widget, gpointer data);
void filter_rules_criteria_ml (GtkWidget *widget, gpointer data);
void filter_rules_criteria_ha (GtkWidget *widget, gpointer data);
void filter_rules_criteria_am (GtkWidget *widget, gpointer data);
void filter_rules_criteria_sca (GtkWidget *widget, gpointer data);

void header_none_selected (GtkWidget *widget, gpointer data);
void header_some_selected (GtkWidget *widget, gpointer data);
void header_all_selected (GtkWidget *widget, gpointer data);*/

void rule_editor_search_target_changed (GtkEditable *entry, FilterRule *rule);
void rule_editor_search_type_changed (GtkEditable *entry, FilterRule *rule);
void rule_editor_action_changed (GtkEditable *entry, FilterRule *rule);
void rule_editor_text_changed (GtkEditable *entry, FilterRule *rule);
void rule_editor_folder_changed (GtkEditable *entry, FilterRule *rule);

void rule_editor_accept (GtkWidget *widget, FilterRule *rule);
void rule_editor_cancel (GtkWidget *widget, FilterRule *rule);
gint rule_editor_destroy (GtkWidget *widget, GdkEvent *event, FilterRule *rule);
void rule_rehash ();

#endif /* _FILTER_CALLBACKS_H_ */
