/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: folder-opts.h,v 1.3 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _FOLDER_OPTS_H_
#define _FOLDER_OPTS_H_

#include "puma.h"

#define CAN_STORE_NEW_MAIL		0x00000001
#define CAN_HAVE_SUBFOLDERS		0x00000002
#define FLAGS_ARE_RECURSIVE		0x00000004

GList *folder_create_glist ();
GList *folder_create_storeable_glist ();
int add_folder_item (char *, GtkCTreeNode *, unsigned long, int);
void create_new_folder (Folder *data);
Folders *seek_folder (int id);
Folders *seek_folder_by_name (char *);
Folders *seek_folder_by_node (GtkCTreeNode *);
void dump_folder (Folders *f);
void destroy_folder (Folders *folder);

#endif /* _FOLDER_OPTS_H_ */
