/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: imap-window-callbacks.h,v 1.4 2001/03/20 20:12:34 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#include <gtk/gtk.h>

#include "puma.h"		/* sheesh */


gboolean
on_imap_window_delete_event (GtkWidget * widget,
			     GdkEvent * event, gpointer user_data);

void on_imap_window_destroy (GtkObject * object, gpointer user_data);

void on_print_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_close_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_exit_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_reply_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_forward_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_delete_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_b_reply_clicked (GtkButton * button, gpointer user_data);

void on_b_forward_clicked (GtkButton * button, gpointer user_data);

void on_b_delete_clicked (GtkButton * button, gpointer user_data);

void
on_imap_clist_click_column (GtkCList * clist,
			    gint column, gpointer user_data);

void
on_imap_clist_select_row (GtkWidget * widget, GdkEventButton * event,
			  gpointer data);

GtkWidget *imap_window_popup_menu (GtkWidget * widget, GList * msel);
void on_imap_unsubscribe_clicked (GtkButton * button, gpointer user_data);
void on_imap_subscribe_clicked (GtkButton * button, gpointer user_data);
void on_imap_subscribe_cancel_clicked (GtkButton * button, gpointer user_data);
