/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: netfolders.h,v 1.5 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>

#include "puma.h"		/* sheesh */
#include "imap-window.h"
#include "imap-window-callbacks.h"


int nf_add_imap_acct (PopAccount * acct);
int nf_imap_folder_sel2 (GtkWidget * widget, GdkEventButton * event,
			 gpointer data);
int nf_imap_folder_sel (GtkCTree * ctree, GList * node, gint column,
			gpointer user_data);
int nf_imap_handle_counts (GtkCTreeNode * node, int unseen, int total);
int nf_imap_handle_folders (GtkCTreeNode * node, char *box);
int nf_imap_handle_list (GtkCTreeNode * node, char *box);
int nf_imap_fill_up (GtkWidget * win, PopAccount * acct, char *mailbox);
GtkWidget *nf_imapf_popup_menu ();
void nf_imap_new_folder (GtkWidget * widget, gpointer userdata);
void nf_imap_delete_folder (GtkWidget * widget, gpointer userdata);
void nf_imap_moveto (GtkWidget * widget, gpointer userdata);
void nf_imap_copyto (GtkWidget * widget, gpointer userdata);
int nf_imap_check_mail (PopAccount *acct);
void nf_imap_subscribe (GtkWidget * widget, gpointer userdata);
void nf_imap_unsubscribe (GtkWidget * widget, gpointer userdata);
