/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: pref-loadsave.h,v 1.6 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _PREF_LOADSAVE_H_
#define _PREF_LOADSAVE_H_

#include "puma.h"

void make_default_prefrances ();
int load_preferences ();
int save_preferences ();
void set_ldap_host( char *var ) ;
void set_ldap_port( char *var ) ;
void set_ldap_username( char *var ) ;
void set_ldap_password( char *var ) ;
void set_ldap_ppassword( char *var ) ;
void set_ldap_base( char *var ) ;
void set_wasted_space (int *value);
void set_printer (char *var);

#endif /* _PREF_LOADSAVE_H_ */
