/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: puma.h,v 1.17 2001/03/20 20:12:35 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifdef write
#undef write
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <fcntl.h>
#include <time.h>
#include <sys/utsname.h>
#include <dirent.h>
#include <errno.h>
#include <netdb.h>
#include <unistd.h>
#include <ctype.h>

#ifndef _PUMA_H_
#define _PUMA_H_

//#define MALLOC_CHECK_ 2

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "parser.h"
#include "globals.h"
#include "mail-loadsave.h"
#include "pipe.h"
#include "main.h"
#include "main-window.h"
#include "new-message-window.h"
#include "new-message-callbacks.h"
#include "new-message.h"
#include "callbacks.h"
#include "support.h"
#include "mime.h"
#include "pref-windows.h"
#include "pref-windows-callbacks.h"
#include "pop3smtp.h"
#include "pref-loadsave.h"
#include "msearch.h"
#include "gcalendar.h"
#include "folder-opts.h"
#include "dialogs.h"
#include "new-folder.h"
#include "abook-main.h"

/*#include "abook-opts.h"
#include "abook-window.h"
#include "abook-callbacks.h"
#include "abook-loadsave.h"*/

#include "forking.h"
#include "status.h"
#include "status-window.h"
#include "status-callbacks.h"
#include "message-fun.h"
#include "filter-windows.h"
#include "filter-opts.h"
#include "filter-callbacks.h"
#include "filter-loadsave.h"
#include "file-selector-window.h"
#include "file-selector-callbacks.h"
#include "message-window.h"
#include "message-callbacks.h"
#include "pixmap.h"
#include "lang-support.h"
#include "calender-opts.h"
#include "schedule-widget.h"
#include "calender-window.h"
#include "calender-callbacks.h"
#include "calender-loadsave.h"
#include "main-window-callbacks.h"
#include "digest-window.h"
#include "schedule-widget.h"
#include "spelling.h"
#include "print.h"
#include "netfolders.h"
#include "spelling-window.h"
#include "spelling-callbacks.h"
#include "clipboard.h"
#include "conv.h"

//C-client
#include "headers.h"

#ifndef addtext
#define	addtext(p,t,l) strncat( p, t, l )
#endif

#ifndef addtext2
#define	addtext2(p,t) strcat( p, t )
#endif

#ifdef SOLARIS25
#define usleep(x)    sleep(x/1000)
#endif


#endif /* _PUMA_H_ */


// MEMWATCH
#ifdef MEMWATCH
#include "memwatch.h"
#endif

// DMALLOC
#ifdef DMALLOC
#include "dmalloc.h"
#endif

