/* TradeClient <http://tradeclient.sourceforge.net>
 * $Id: new-message-window.c,v 1.47 2001/03/20 22:19:33 ttabner Exp $
 *
 * Copyright (C) 1999-2000 Bynari Inc.
 * Copyright (C) 2001 Project TradeClient
 *
 * LGPL
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "puma.h"

GtkWidget *create_new_message_window2 (void) {
  GtkWidget *new_message_window;
  GtkWidget *vbox1;
  GtkWidget *handlebox1;
  GtkWidget *vbox5;
  GtkWidget *menubar1;
  GtkWidget *menuitem1;
  GtkWidget *menuitem1_menu;
  GtkAccelGroup *menuitem1_menu_accels;
  GtkWidget *menuitem2;
  GtkWidget *menuitem3;
  GtkWidget *menuitem3_menu;
  GtkAccelGroup *menuitem3_menu_accels;
  GtkWidget *menuitem4;
  GtkWidget *menuitem13;
/* not used right now
  GtkWidget *menuitem14;
  GtkWidget *menuitem15;
  GtkWidget *menuitem16;
*/
  GtkWidget *menuitem17;
  GtkWidget *menuitem18;
  GtkWidget *menuitem19;
  GtkWidget *menuitem25;
  GtkWidget *menuitem26;
  GtkWidget *menuitem74;
  GtkWidget *menuitem74_menu;
  GtkWidget *tearoff;
  GtkAccelGroup *menuitem74_menu_accels;
  GtkWidget *menuitem75;
  GtkWidget *menuitem77;
  GtkWidget *menuitem78;
  GtkWidget *menuitem79;
  GtkWidget *menuitem80;
  GtkWidget *menuitem95;
  GtkWidget *menuitem95_menu;
  GtkAccelGroup *menuitem95_menu_accels;
  GtkWidget *menuitem96;
  GtkWidget *menuitem97;
  GtkWidget *menuitem98;
  GtkWidget *menuitem99;
  GtkWidget *hbox1;
  GtkWidget *send_button;
  GtkWidget *vseparator1;
  GtkWidget *save_button;
  GtkWidget *print_button;
  GtkWidget *vseparator2;
  GtkWidget *attach_button;
  GtkWidget *vseparator3;
  GtkWidget *address_book_button;
  GtkWidget *spell_check_button;
  GtkWidget *encrypt_button;
  GtkWidget *notebook1;
  GtkWidget *frame8;
  GtkWidget *vbox3;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *subject_entry;
  GtkWidget *scrolledwindow6;
  GtkWidget *viewport2;
  GtkWidget *recip_tree;
  GtkWidget *scrolledwindow1;
  GtkWidget *body_textbox;
  GtkWidget *label2;
  GtkWidget *frame12;
  GtkWidget *scrolledwindow4;
  GtkWidget *viewport1;
  GtkWidget *vbox9;
  GtkWidget *hbox10;
  GtkWidget *add_attachment;
  GtkWidget *remove_attachment;
  GtkWidget *scrolledwindow5;
  GtkWidget *attachment_clist;
  GtkWidget *label31;
  GtkWidget *label32;
  GtkWidget *label33;
  GtkWidget *label28;
  GtkWidget *frame7;
  GtkWidget *vbox4;
  GtkWidget *frame4;
  GtkWidget *combo2;
  GtkWidget *account_to_use;
  GtkWidget *vbox12;
  GtkWidget *frame50;
  GtkWidget *combo12;
  GtkWidget *priority_to_use;
  GtkWidget *sensitivity_to_use;
  GList *combo12_items = NULL;
  GtkWidget *hbox3;
  GtkWidget *return_receipt;
  GtkWidget *label6;
  GtkWidget *hbox4;
  GtkWidget *message_delayed;
  GtkWidget *label7;
  GtkObject *wwrap_val_adj;
  GtkWidget *wwrap_frm, *wwrap_box, *wwrap_tog, *wwrap_lbl, *wwrap_val;
  GtkWidget *keyword_frm, *keyword_box, *sensitivity_frm, *sensitivity_box;
  GtkWidget *sens_combo, *select_categories, *entry9;
  GList *sens_combo_items = NULL;
  GtkWidget *msg_exp_box, *msg_exp_label, *msg_exp_entry;
  GtkWidget *replyby_box, *replyby_label, *replyby_entry;
  GtkWidget *label5;
  GtkWidget *hseparator3;
  GtkWidget *frame6;
  GtkWidget *label8;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;
  GtkWidget *nwscroll, *nwviewport;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  new_message_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (new_message_window, "new_message_window");
  gtk_object_set_data (GTK_OBJECT (new_message_window), "new_message_window", new_message_window);
  gtk_window_set_title (GTK_WINDOW (new_message_window), _("Compose A New Message"));
  gtk_widget_set_usize (new_message_window, 500,440);
  gtk_window_set_default_size (GTK_WINDOW(new_message_window), tm_globs->wsize.new_message_window.x, tm_globs->wsize.new_message_window.y);
  gtk_window_set_policy (GTK_WINDOW (new_message_window), TRUE, TRUE, TRUE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (new_message_window), vbox1);

  handlebox1 = gtk_handle_box_new ();
  gtk_widget_set_name (handlebox1, "handlebox1");
  gtk_widget_ref (handlebox1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "handlebox1", handlebox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox1);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox1, FALSE, FALSE, 0);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (handlebox1), vbox5);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar1, "menubar1");
  gtk_widget_ref (menubar1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menubar1", menubar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox5), menubar1, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (menubar1), GTK_SHADOW_ETCHED_IN);

  menuitem1 = gtk_menu_item_new_with_label (_("File"));
  gtk_widget_set_name (menuitem1, "menuitem1");
  gtk_widget_ref (menuitem1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem1", menuitem1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem1);

  menuitem1_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem1_menu, "menuitem1_menu");
  gtk_widget_ref (menuitem1_menu);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem1_menu", menuitem1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menuitem1_menu);
  menuitem1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem1_menu));

  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), tearoff);

  menuitem2 = gtk_menu_item_new_with_label (_("Send Message"));
  gtk_widget_set_name (menuitem2, "menuitem2");
  gtk_widget_ref (menuitem2);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem2", menuitem2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem2);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem2);
  gtk_widget_add_accelerator (menuitem2, "activate", accel_group,
                              GDK_s, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem3 = gtk_menu_item_new_with_label (_("New"));
  gtk_widget_set_name (menuitem3, "menuitem3");
  gtk_widget_ref (menuitem3);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem3", menuitem3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem3);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem3);

  menuitem3_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem3_menu, "menuitem3_menu");
  gtk_widget_ref (menuitem3_menu);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem3_menu", menuitem3_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem3), menuitem3_menu);
  menuitem3_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem3_menu));

  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), tearoff);
  
  menuitem4 = gtk_menu_item_new_with_label (_("Mail Message"));
  gtk_widget_set_name (menuitem4, "menuitem4");
  gtk_widget_ref (menuitem4);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem4", menuitem4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem4);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), menuitem4);
  gtk_widget_add_accelerator (menuitem4, "activate", accel_group,
                              GDK_n, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem13 = gtk_menu_item_new_with_label (_("Addressbook Entry"));
  gtk_widget_set_name (menuitem13, "menuitem13");
  gtk_widget_ref (menuitem13);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem13", menuitem13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem13);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), menuitem13);
  gtk_widget_add_accelerator (menuitem13, "activate", accel_group,
                              GDK_e, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  /*
  menuitem14 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem14, "menuitem14");
  gtk_widget_ref (menuitem14);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem14", menuitem14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem14);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), menuitem14);
  gtk_widget_set_sensitive (menuitem14, FALSE);

  menuitem15 = gtk_menu_item_new_with_label (_("Choose Template..."));
  gtk_widget_set_name (menuitem15, "menuitem15");
  gtk_widget_ref (menuitem15);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem15", menuitem15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem15);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), menuitem15);

  menuitem16 = gtk_menu_item_new_with_label (_("Choose Form..."));
  gtk_widget_set_name (menuitem16, "menuitem16");
  gtk_widget_ref (menuitem16);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem16", menuitem16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem16);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), menuitem16);
  */

  menuitem17 = gtk_menu_item_new_with_label (_("Save"));
  gtk_widget_set_name (menuitem17, "menuitem17");
  gtk_widget_ref (menuitem17);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem17", menuitem17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem17);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem17);

  menuitem18 = gtk_menu_item_new_with_label (_("Print"));
  gtk_widget_set_name (menuitem18, "menuitem18");
  gtk_widget_ref (menuitem18);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem18", menuitem18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem18);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem18);
  gtk_widget_add_accelerator (menuitem18, "activate", accel_group,
                              GDK_p, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem19 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem19, "menuitem19");
  gtk_widget_ref (menuitem19);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem19", menuitem19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem19);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem19);
  gtk_widget_set_sensitive (menuitem19, FALSE);


  menuitem25 = gtk_menu_item_new_with_label (_("Close"));
  gtk_widget_set_name (menuitem25, "menuitem25");
  gtk_widget_ref (menuitem25);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem25", menuitem25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem25);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem25);
  gtk_widget_add_accelerator (menuitem25, "activate", accel_group,
                              GDK_w, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  seper_new(menuitem1_menu);

  menuitem26 = gtk_menu_item_new_with_label (_("Exit TradeClient"));
  gtk_widget_set_name (menuitem26, "menuitem26");
  gtk_widget_ref (menuitem26);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem26", menuitem26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem26);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), menuitem26);
  gtk_widget_add_accelerator (menuitem26, "activate", accel_group,
                              GDK_q, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);



	clip_create_menuitem (menubar1, accel_group);


  menuitem74 = gtk_menu_item_new_with_label (_("Tools"));
  gtk_widget_set_name (menuitem74, "menuitem74");
  gtk_widget_ref (menuitem74);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem74", menuitem74,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem74);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem74);

  menuitem74_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem74_menu, "menuitem74_menu");
  gtk_widget_ref (menuitem74_menu);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem74_menu", menuitem74_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem74), menuitem74_menu);
  menuitem74_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem74_menu));

  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (menuitem74_menu), tearoff);

  menuitem75 = gtk_menu_item_new_with_label (_("Spelling..."));
  gtk_widget_set_name (menuitem75, "menuitem75");
  gtk_widget_ref (menuitem75);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem75", menuitem75,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem75);
  gtk_container_add (GTK_CONTAINER (menuitem74_menu), menuitem75);

  menuitem77 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem77, "menuitem77");
  gtk_widget_ref (menuitem77);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem77", menuitem77,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem77);
  gtk_container_add (GTK_CONTAINER (menuitem74_menu), menuitem77);
  gtk_widget_set_sensitive (menuitem77, FALSE);

  menuitem78 = gtk_menu_item_new_with_label (_("Check Names"));
  gtk_widget_set_name (menuitem78, "menuitem78");
  gtk_widget_ref (menuitem78);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem78", menuitem78,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem78);
  gtk_container_add (GTK_CONTAINER (menuitem74_menu), menuitem78);

  menuitem79 = gtk_menu_item_new_with_label (_("Address Book..."));
  gtk_widget_set_name (menuitem79, "menuitem79");
  gtk_widget_ref (menuitem79);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem79", menuitem79,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem79);
  gtk_container_add (GTK_CONTAINER (menuitem74_menu), menuitem79);
  gtk_widget_add_accelerator (menuitem79, "activate", accel_group,
                              GDK_b, GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  menuitem80 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem80, "menuitem80");
  gtk_widget_ref (menuitem80);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem80", menuitem80,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (menuitem80);*/
  gtk_container_add (GTK_CONTAINER (menuitem74_menu), menuitem80);
  gtk_widget_set_sensitive (menuitem80, FALSE);

  menuitem95 = gtk_menu_item_new_with_label (_("Help"));
  gtk_widget_set_name (menuitem95, "menuitem95");
  gtk_widget_ref (menuitem95);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem95", menuitem95,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem95);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem95);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (menuitem95));

  menuitem95_menu = gtk_menu_new ();
  gtk_widget_set_name (menuitem95_menu, "menuitem95_menu");
  gtk_widget_ref (menuitem95_menu);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem95_menu", menuitem95_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem95), menuitem95_menu);
  menuitem95_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menuitem95_menu));

  tearoff=gtk_tearoff_menu_item_new ();
  gtk_widget_show (tearoff);
  gtk_container_add (GTK_CONTAINER (menuitem95_menu), tearoff);

  menuitem96 = gtk_menu_item_new_with_label (_("TradeClient Help"));
  gtk_widget_set_name (menuitem96, "menuitem96");
  gtk_widget_ref (menuitem96);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem96", menuitem96,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (menuitem96);*/
  gtk_container_add (GTK_CONTAINER (menuitem95_menu), menuitem96);

  menuitem97 = gtk_menu_item_new_with_label (_("Contents and Index"));
  gtk_widget_set_name (menuitem97, "menuitem97");
  gtk_widget_ref (menuitem97);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem97", menuitem97,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (menuitem97);*/
  gtk_container_add (GTK_CONTAINER (menuitem95_menu), menuitem97);

  menuitem98 = gtk_menu_item_new ();
  gtk_widget_set_name (menuitem98, "menuitem98");
  gtk_widget_ref (menuitem98);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem98", menuitem98,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (menuitem98);*/
  gtk_container_add (GTK_CONTAINER (menuitem95_menu), menuitem98);
  gtk_widget_set_sensitive (menuitem98, FALSE);

  menuitem99 = gtk_menu_item_new_with_label (_("About TradeClient"));
  gtk_widget_set_name (menuitem99, "menuitem99");
  gtk_widget_ref (menuitem99);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "menuitem99", menuitem99,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menuitem99);
  gtk_container_add (GTK_CONTAINER (menuitem95_menu), menuitem99);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox1, TRUE, TRUE, 0);

  send_button = gtk_button_new ();
  gtk_widget_set_name (send_button, "send_button");
  gtk_widget_ref (send_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "send_button", send_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (send_button);
  /*gtk_box_pack_start (GTK_BOX (hbox1), send_button, FALSE, FALSE, 0);*/
  gtk_tooltips_set_tip (tooltips, send_button, _("Send the current message"), NULL);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_set_name (vseparator1, "vseparator1");
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  /*gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, TRUE, 4);*/

  save_button = gtk_button_new ();
  gtk_widget_set_name (save_button, "save_button");
  gtk_widget_ref (save_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "save_button", save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_button);
  /*gtk_box_pack_start (GTK_BOX (hbox1), save_button, FALSE, FALSE, 0);*/
  gtk_tooltips_set_tip (tooltips, save_button, _("Save message for later usage"), NULL);

  print_button = gtk_button_new ();
  gtk_widget_set_name (print_button, "print_button");
  gtk_widget_ref (print_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "print_button", print_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (print_button);
  /*gtk_box_pack_start (GTK_BOX (hbox1), print_button, FALSE, FALSE, 0);*/
  gtk_tooltips_set_tip (tooltips, print_button, _("Print this message"), NULL);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_set_name (vseparator2, "vseparator2");
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator2);
  /*gtk_box_pack_start (GTK_BOX (hbox1), vseparator2, FALSE, TRUE, 4);*/

  attach_button = gtk_button_new ();
  gtk_widget_set_name (attach_button, "attach_button");
  gtk_widget_ref (attach_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "attach_button", attach_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (attach_button);
  /*gtk_box_pack_start (GTK_BOX (hbox1), attach_button, FALSE, FALSE, 0);*/
  gtk_tooltips_set_tip (tooltips, attach_button, _("Attach a file to this message"), NULL);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_set_name (vseparator3, "vseparator3");
  gtk_widget_ref (vseparator3);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vseparator3", vseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator3);
  /*gtk_box_pack_start (GTK_BOX (hbox1), vseparator3, FALSE, TRUE, 4);*/

  address_book_button = gtk_button_new ();
  gtk_widget_set_name (address_book_button, "address_book_button");
  gtk_widget_ref (address_book_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "address_book_button", address_book_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_book_button);
  /*gtk_box_pack_start (GTK_BOX (hbox1), address_book_button, FALSE, FALSE,0);*/
  gtk_tooltips_set_tip (tooltips, address_book_button, _("Edit your Address Book"), NULL);

  spell_check_button = gtk_button_new();
  gtk_widget_set_name (spell_check_button, "spell_check_button");
  gtk_widget_ref (spell_check_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window),
		  "spell_check_button", spell_check_button,
		  (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spell_check_button);
  gtk_tooltips_set_tip (tooltips, spell_check_button,
		  _("Check spelling"), NULL);

  encrypt_button = gtk_button_new ();
  gtk_widget_set_name (encrypt_button, "encrypt_button");
  gtk_widget_ref (encrypt_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "encrypt_button", encrypt_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (encrypt_button);
  /*gtk_box_pack_start (GTK_BOX (hbox1), encrypt_button, FALSE, FALSE, 0);*/
  gtk_tooltips_set_tip (tooltips, encrypt_button, _("Encrypt this message"), NULL);

/*  sign_button = gtk_button_new ();
  gtk_widget_set_name (sign_button, "sign_button");
  gtk_widget_ref (sign_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "sign_button", sign_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sign_button);
  gtk_box_pack_start (GTK_BOX (hbox1), sign_button, FALSE, FALSE, 0);
  gtk_tooltips_set_tip (tooltips, sign_button, _("Sign this message with your Autosignature"), NULL);*/
  gtk_box_pack_start (GTK_BOX (hbox1), send_button, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, TRUE, 4);
  gtk_box_pack_start (GTK_BOX (hbox1), attach_button, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator2, FALSE, TRUE, 4);
  gtk_box_pack_start (GTK_BOX (hbox1), address_book_button, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), spell_check_button, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), print_button, FALSE, FALSE, 0);
/* XXX we'll show this after we implement it
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator3, FALSE, TRUE, 4);
  gtk_box_pack_start (GTK_BOX (hbox1), encrypt_button, FALSE, FALSE, 0);
*/
  notebook1 = gtk_notebook_new ();
  gtk_widget_set_name (notebook1, "notebook1");
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (vbox1), notebook1, TRUE, TRUE, 0);

  frame8 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame8, "frame8");
  gtk_widget_ref (frame8);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "frame8", frame8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame8);
  gtk_container_add (GTK_CONTAINER (notebook1), frame8);
  gtk_container_set_border_width (GTK_CONTAINER (frame8), 2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (frame8), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 2);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox3), table1, FALSE, TRUE, 0);

  label1 = gtk_label_new (_("Subject"));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 3, 0);

  subject_entry = gtk_entry_new ();
  gtk_widget_set_name (subject_entry, "subject_entry");
  gtk_widget_ref (subject_entry);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "subject_entry", subject_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (subject_entry);
  gtk_table_attach (GTK_TABLE (table1), subject_entry, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 5, 3);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow6, "scrolledwindow6");
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_table_attach (GTK_TABLE (table1), scrolledwindow6, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport2 = gtk_viewport_new (NULL, NULL);
  gtk_widget_set_name (viewport2, "viewport2");
  gtk_widget_ref (viewport2);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "viewport2", viewport2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), viewport2);

  recip_tree = gtk_tree_new ();
  gtk_widget_set_name (recip_tree, "recip_tree");
  gtk_widget_ref (recip_tree);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "recip_tree", recip_tree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (recip_tree);
  gtk_container_add (GTK_CONTAINER (viewport2), recip_tree);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  body_textbox = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (body_textbox, "body_textbox");
  gtk_widget_ref (body_textbox);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "body_textbox", body_textbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (body_textbox);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), body_textbox);
  gtk_text_set_editable (GTK_TEXT (body_textbox), TRUE);

  label2 = gtk_label_new (_("Message"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label2);

  frame12 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame12, "frame12");
  gtk_widget_ref (frame12);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "frame12", frame12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame12);
  gtk_container_add (GTK_CONTAINER (notebook1), frame12);
  gtk_container_set_border_width (GTK_CONTAINER (frame12), 2);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow4, "scrolledwindow4");
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_container_add (GTK_CONTAINER (frame12), scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_set_name (viewport1, "viewport1");
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), viewport1);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox9, "vbox9");
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (viewport1), vbox9);
  gtk_container_set_border_width (GTK_CONTAINER (vbox9), 2);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox10, "hbox10");
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox10, FALSE, FALSE, 0);

  add_attachment = gtk_button_new_with_label (_("Add Attachment"));
  gtk_widget_set_name (add_attachment, "add_attachment");
  gtk_widget_ref (add_attachment);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "add_attachment", add_attachment,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_attachment);
  gtk_box_pack_start (GTK_BOX (hbox10), add_attachment, TRUE, FALSE, 0);

  remove_attachment = gtk_button_new_with_label (_("Remove Attachment"));
  gtk_widget_set_name (remove_attachment, "remove_attachment");
  gtk_widget_ref (remove_attachment);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "remove_attachment", remove_attachment,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (remove_attachment);
  gtk_box_pack_start (GTK_BOX (hbox10), remove_attachment, TRUE, FALSE, 0);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow5, "scrolledwindow5");
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_box_pack_start (GTK_BOX (vbox9), scrolledwindow5, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  attachment_clist = gtk_clist_new (3);
  gtk_widget_set_name (attachment_clist, "attachment_clist");
  gtk_widget_ref (attachment_clist);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "attachment_clist", attachment_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (attachment_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), attachment_clist);

  gtk_clist_set_column_width (GTK_CLIST (attachment_clist), 0, tm_globs->cpos.nmsgw[0]);
  gtk_clist_set_column_width (GTK_CLIST (attachment_clist), 1, tm_globs->cpos.nmsgw[1]);
  gtk_clist_set_column_width (GTK_CLIST (attachment_clist), 2, tm_globs->cpos.nmsgw[2]);
  gtk_clist_column_titles_show (GTK_CLIST (attachment_clist));

  gtk_signal_connect (GTK_OBJECT (attachment_clist), "resize_column",
                         GTK_SIGNAL_FUNC (cpos_set_nmsgw), NULL);

  label31 = gtk_label_new (_("Content Type"));
  gtk_widget_set_name (label31, "label31");
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_clist_set_column_widget (GTK_CLIST (attachment_clist), 0, label31);

  label32 = gtk_label_new (_("Filename"));
  gtk_widget_set_name (label32, "label32");
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_clist_set_column_widget (GTK_CLIST (attachment_clist), 1, label32);

  label33 = gtk_label_new (_("Size"));
  gtk_widget_set_name (label33, "label33");
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_clist_set_column_widget (GTK_CLIST (attachment_clist), 2, label33);

  label28 = gtk_label_new (_("Attachments"));
  gtk_widget_set_name (label28, "label28");
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label28);

  nwscroll = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (nwscroll);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "nwscroll",
		nwscroll, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nwscroll);
  gtk_container_add (GTK_CONTAINER (notebook1), nwscroll);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (nwscroll),
                GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  nwviewport = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (nwviewport);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "nwviewport",
		nwviewport, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nwviewport);
  gtk_container_add (GTK_CONTAINER (nwscroll), nwviewport);

  frame7 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame7, "frame7");
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame7);
  gtk_container_add (GTK_CONTAINER (nwviewport), frame7);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 2);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame7), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 2);

  frame4 = gtk_frame_new (_("Which account to send message through"));
  gtk_widget_set_name (frame4, "frame4");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (vbox4), frame4, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 2);

  combo2 = gtk_combo_new ();
  gtk_widget_set_name (combo2, "combo2");
  gtk_widget_ref (combo2);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "combo2", combo2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo2);
  gtk_container_add (GTK_CONTAINER (frame4), combo2);
  gtk_container_set_border_width (GTK_CONTAINER (combo2), 2);

  account_to_use = GTK_COMBO (combo2)->entry;
  gtk_widget_set_name (account_to_use, "account_to_use");
  gtk_widget_ref (account_to_use);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "account_to_use", account_to_use,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (account_to_use);
  gtk_entry_set_editable (GTK_ENTRY (account_to_use), FALSE);

  frame50 = gtk_frame_new (_("Message Priority:"));
  gtk_widget_set_name (frame50, "frame50");
  gtk_widget_ref (frame50);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "frame50", frame50,
				           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame50);
  gtk_box_pack_start (GTK_BOX (vbox4), frame50, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame50), 2);
  gtk_widget_set_sensitive (frame50, TRUE);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox12, "vbox12");
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox12", vbox12,
		   (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(vbox12);
  gtk_container_add (GTK_CONTAINER (frame50), vbox12);
  gtk_container_set_border_width (GTK_CONTAINER (vbox12), 2);

  combo12 = gtk_combo_new ();
  gtk_widget_set_name (combo12, "combo12");
  gtk_widget_ref(combo12);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "combo12", combo12,
				           (GtkDestroyNotify) gtk_widget_unref);
  ws (combo12);
  combo12_items = g_list_append (combo12_items, _("1 (Highest)"));
  combo12_items = g_list_append (combo12_items, _("2 (High)"));
  combo12_items = g_list_append (combo12_items, _("3 (Normal)"));
  combo12_items = g_list_append (combo12_items, _("4 (Low)"));
  combo12_items = g_list_append (combo12_items, _("5 (Lowest)"));
  gtk_combo_set_popdown_strings (GTK_COMBO (combo12), combo12_items);
  g_list_free (combo12_items);
  gtk_container_add (GTK_CONTAINER (vbox12), combo12); 
  gtk_widget_set_sensitive (combo12, TRUE);
  
  priority_to_use = GTK_COMBO (combo12)->entry;
  gtk_widget_set_name (priority_to_use, "priority_to_use");
  gtk_widget_ref (priority_to_use);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "priority_to_use", priority_to_use,
				  	       (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (priority_to_use);
  gtk_entry_set_editable (GTK_ENTRY (priority_to_use), FALSE);
  gtk_entry_set_text (GTK_ENTRY (priority_to_use), _("3 (Normal)"));

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox3, FALSE, FALSE, 0);

  return_receipt = gtk_check_button_new_with_label ("");
  gtk_widget_set_name (return_receipt, "return_receipt");
  gtk_widget_ref (return_receipt);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "return_receipt", return_receipt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (return_receipt);
  gtk_box_pack_start (GTK_BOX (hbox3), return_receipt, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (return_receipt, TRUE);

  label6 = gtk_label_new (_("Request Return Receipt"));
  gtk_widget_set_name (label6, "label6");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox3), label6, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (label6, TRUE);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox4, FALSE, FALSE, 0);

  message_delayed = gtk_check_button_new_with_label ("");
  gtk_widget_set_name (message_delayed, "message_delayed");
  gtk_widget_ref (message_delayed);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "message_delayed", message_delayed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_delayed);
  gtk_box_pack_start (GTK_BOX (hbox4), message_delayed, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (message_delayed, FALSE);

  label7 = gtk_label_new (_("Store this message in Outbox until a full Send/Receive"));
  gtk_widget_set_name (label7, "label7");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (hbox4), label7, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (label7, FALSE);

  wwrap_val_adj = gtk_adjustment_new( 72, 20, 160, 1, 10, 10 ) ;

  wwrap_frm = gtk_frame_new( _("Word wrapping") ) ;
  gtk_widget_set_name( wwrap_frm, "wwrap_frm" ) ;
  gtk_widget_ref( wwrap_frm ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "wwrap_frm",
		  wwrap_frm, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( wwrap_frm ) ;
  gtk_box_pack_start( GTK_BOX( vbox4 ), wwrap_frm, FALSE, TRUE, 0 ) ;
  gtk_container_set_border_width (GTK_CONTAINER (wwrap_frm), 2);

  wwrap_box = gtk_hbox_new( FALSE, 0 ) ;
  gtk_widget_set_name( wwrap_box, "wwrap_box" ) ;
  gtk_widget_ref( wwrap_box ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "wwrap_box",
		  wwrap_box, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( wwrap_box ) ;
  gtk_container_add( GTK_CONTAINER( wwrap_frm ), wwrap_box ) ;
  gtk_container_set_border_width (GTK_CONTAINER (wwrap_box), 2);

  wwrap_tog = gtk_check_button_new_with_label( "" ) ;
  gtk_widget_set_name( wwrap_tog, "wwrap_tog" ) ;
  gtk_widget_ref( wwrap_tog ) ;
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "wwrap_tog", wwrap_tog, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show( wwrap_tog ) ;
  gtk_box_pack_start( GTK_BOX( wwrap_box ), wwrap_tog, FALSE, FALSE, 0 ) ;
  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wwrap_tog ), TRUE );

  wwrap_lbl = gtk_label_new ( _("Text width  ") ) ;
  gtk_widget_set_name( wwrap_lbl, "wwrap_lbl" );
  gtk_widget_ref( wwrap_lbl );
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "wwrap_lbl",
		  wwrap_lbl, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( wwrap_lbl ) ;
  gtk_box_pack_start( GTK_BOX( wwrap_box ), wwrap_lbl, FALSE, FALSE, 0 ) ;

  wwrap_val = gtk_spin_button_new( GTK_ADJUSTMENT( wwrap_val_adj ), 1, 0 ) ;
  gtk_widget_set_name( wwrap_val, "wwrap_val" ) ;
  gtk_widget_ref( wwrap_val ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window), "wwrap_val",
		  wwrap_val, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( wwrap_val ) ;
  gtk_box_pack_start(GTK_BOX( wwrap_box ), wwrap_val, FALSE, FALSE, 0 ) ;

  if(!tm_globs->wwrap)
  	tm_globs -> wwrap = gtk_spin_button_get_value_as_int(
			GTK_SPIN_BUTTON( wwrap_val )) ;
  gtk_spin_button_set_value( GTK_SPIN_BUTTON( wwrap_val ), tm_globs->wwrap );

  keyword_frm = gtk_frame_new( _("Select Keywords") ) ;
  gtk_widget_set_name( keyword_frm, "keyword_frm" ) ;
  gtk_widget_ref( keyword_frm ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "keyword_frm",
                  keyword_frm, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( keyword_frm ) ;
  gtk_box_pack_start( GTK_BOX( vbox4 ), keyword_frm, FALSE, TRUE, 0 ) ;
  gtk_container_set_border_width (GTK_CONTAINER (keyword_frm), 2);

  keyword_box = gtk_hbox_new( FALSE, 0 ) ;
  gtk_widget_set_name( keyword_box, "keyword_box" ) ;
  gtk_widget_ref( keyword_box ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "keyword_box",
                  keyword_box, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( keyword_box ) ;
  gtk_container_add( GTK_CONTAINER( keyword_frm ), keyword_box ) ;
  gtk_container_set_border_width (GTK_CONTAINER (keyword_box), 2);

  select_categories = gtk_button_new_with_label (_("Categories"));
  gtk_widget_set_name (select_categories, "select_categories");
  gtk_widget_ref (select_categories);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window),
	"select_categories", select_categories,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (select_categories);
  gtk_box_pack_start (GTK_BOX (keyword_box), select_categories,FALSE,FALSE,0);

  entry9 = gtk_entry_new ();
  gtk_widget_set_name (entry9, "entry9");
  gtk_widget_ref (entry9);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "entry9",
	entry9, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry9);
  gtk_box_pack_start (GTK_BOX (keyword_box), entry9, TRUE, TRUE, 0);


  sensitivity_frm = gtk_frame_new( _("Message Sensitivity") ) ;
  gtk_widget_set_name( sensitivity_frm, "sensitivity_frm" ) ;
  gtk_widget_ref( sensitivity_frm ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "sensitivity_frm",
                  sensitivity_frm, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( sensitivity_frm ) ;
  gtk_box_pack_start( GTK_BOX( vbox4 ), sensitivity_frm, FALSE, TRUE, 0 ) ;
  gtk_container_set_border_width (GTK_CONTAINER (sensitivity_frm), 2);

  sensitivity_box = gtk_hbox_new( FALSE, 0 ) ;
  gtk_widget_set_name( sensitivity_box, "sensitivity_box" ) ;
  gtk_widget_ref( sensitivity_box ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "sensitivity_box",
                  sensitivity_box, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( sensitivity_box ) ;
  gtk_container_add( GTK_CONTAINER( sensitivity_frm ), sensitivity_box ) ;
  gtk_container_set_border_width (GTK_CONTAINER (sensitivity_box), 2);

  sens_combo = gtk_combo_new ();
  gtk_widget_set_name (sens_combo, "sens_combo");
  gtk_widget_ref(sens_combo);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "sens_combo",
	sens_combo, (GtkDestroyNotify) gtk_widget_unref);
  ws (sens_combo);
  sens_combo_items = g_list_append (sens_combo_items, _("Public-Document"));
  sens_combo_items = g_list_append (sens_combo_items, _("Internal-Document"));
  sens_combo_items = g_list_append (sens_combo_items, _("Personal"));
  sens_combo_items = g_list_append (sens_combo_items, _("Private"));
  sens_combo_items = g_list_append (sens_combo_items, _("Company-Confidential"));
#if 0
  sens_combo_items = g_list_append (sens_combo_items, _("Un-Classified")) ;
#endif
  gtk_combo_set_popdown_strings (GTK_COMBO (sens_combo), sens_combo_items);
  g_list_free (sens_combo_items);
  gtk_box_pack_start (GTK_BOX (sensitivity_box), sens_combo, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (sens_combo, TRUE);

  sensitivity_to_use = GTK_COMBO (sens_combo)->entry;
  gtk_widget_set_name (sensitivity_to_use, "sensitivity_to_use");
  gtk_widget_ref (sensitivity_to_use);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "sensitivity_to_use",
        sensitivity_to_use, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sensitivity_to_use);
  gtk_entry_set_editable (GTK_ENTRY (sensitivity_to_use), FALSE);
  gtk_entry_set_text (GTK_ENTRY (sensitivity_to_use), _("Public-Document"));


  msg_exp_box = gtk_hbox_new( FALSE, 0 ) ;
  gtk_widget_set_name( msg_exp_box, "msg_exp_box" ) ;
  gtk_widget_ref( msg_exp_box ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "msg_exp_box",
                  msg_exp_box, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( msg_exp_box ) ;
  gtk_box_pack_start(GTK_BOX(vbox4), msg_exp_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (msg_exp_box), 2);

  msg_exp_label = gtk_button_new_with_label ("Message Expiration");
  gtk_widget_set_name (msg_exp_label, "msg_exp_label");
  gtk_widget_ref (msg_exp_label);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "msg_exp_label",
	msg_exp_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (msg_exp_label);
  gtk_box_pack_start (GTK_BOX (msg_exp_box), msg_exp_label, FALSE, FALSE, 0);

  msg_exp_entry = gtk_entry_new ();
  gtk_widget_set_name (msg_exp_entry, "msg_exp_entry");
  gtk_widget_ref (msg_exp_entry);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "msg_exp_entry",
	msg_exp_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (msg_exp_entry);
  gtk_box_pack_start (GTK_BOX (msg_exp_box), msg_exp_entry, TRUE, TRUE, 0);


  replyby_box = gtk_hbox_new( FALSE, 0 ) ;
  gtk_widget_set_name( replyby_box, "replyby_box" ) ;
  gtk_widget_ref( replyby_box ) ;
  gtk_object_set_data_full( GTK_OBJECT( new_message_window ), "replyby_box",
                  replyby_box, (GtkDestroyNotify) gtk_widget_unref ) ;
  gtk_widget_show( replyby_box ) ;
  gtk_box_pack_start(GTK_BOX(vbox4), replyby_box, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (replyby_box), 2);

  replyby_label = gtk_button_new_with_label ("Reply By");
  gtk_widget_set_name (replyby_label, "replyby_label");
  gtk_widget_ref (replyby_label);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "replyby_label",
        replyby_label, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (replyby_label);
  gtk_box_pack_start (GTK_BOX (replyby_box), replyby_label, FALSE, FALSE, 0);

  replyby_entry = gtk_entry_new ();
  gtk_widget_set_name (replyby_entry, "replyby_entry");
  gtk_widget_ref (replyby_entry);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "replyby_entry",
        replyby_entry, (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (replyby_entry);
  gtk_box_pack_start (GTK_BOX (replyby_box), replyby_entry, TRUE, TRUE, 0);


  label5 = gtk_label_new (_("Options"));
  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label5);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator3, "hseparator3");
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator3, FALSE, TRUE, 2);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame6, "frame6");
  gtk_widget_ref (frame6);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "frame6", frame6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox1), frame6, FALSE, FALSE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (frame6), GTK_SHADOW_IN);

  label8 = gtk_label_new ("");
  gtk_widget_set_name (label8, "label8");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_container_add (GTK_CONTAINER (frame6), label8);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);

  gtk_object_set_data (GTK_OBJECT (new_message_window), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (new_message_window), accel_group);

  return new_message_window;
}


GtkWidget *
new_message_window_add_recip( GtkWidget *placeholder, RecipSignalData *recip )
{
  GtkWidget *hbox11;
  GtkWidget *button1;
  GtkWidget *combo3;
  GtkWidget *send_type;
  GtkWidget *address;
     GtkWidget *menuitem ;
     GList *combo3_items ;
RecipSignalData *newrecip = (RecipSignalData *)calloc (1, sizeof (RecipSignalData));

	newrecip->tree = recip->tree;

     if( recip == NULL ) return NULL ;
     g_return_val_if_fail( recip -> tree != NULL, NULL ) ;
	newrecip->tree = recip->tree;

#if DEBUG > 6
     printf( "RecipSignalData pointer is %p.\n", recip ) ;
#endif

	menuitem=gtk_tree_item_new ();
	gtk_widget_show (menuitem);
     gtk_tree_append (recip -> tree, menuitem);

	hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox11, "hbox11");
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (menuitem), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (menuitem), hbox11);

  button1 = gtk_button_new_with_label (_("To:..."));
  gtk_widget_set_name (button1, "button1");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (menuitem), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (hbox11), button1, FALSE, FALSE, 0);

  combo3 = gtk_combo_new ();
  gtk_widget_set_name (combo3, "combo3");
  gtk_widget_ref (combo3);
  gtk_object_set_data_full (GTK_OBJECT (menuitem), "combo3", combo3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo3);
  gtk_box_pack_start (GTK_BOX (hbox11), combo3, FALSE, FALSE, 0);
  gtk_widget_set_usize (combo3, 62, -2);
     combo3_items = NULL ;
  combo3_items = g_list_append (combo3_items, _("To:"));
  combo3_items = g_list_append (combo3_items, _("Cc:"));
  combo3_items = g_list_append (combo3_items, _("Bcc:"));
  gtk_combo_set_popdown_strings (GTK_COMBO (combo3), combo3_items);
	
  g_list_free (combo3_items);

  send_type = GTK_COMBO (combo3)->entry;
  gtk_widget_set_name (send_type, "send_type");
  gtk_widget_ref (send_type);
  gtk_object_set_data_full (GTK_OBJECT (menuitem), "send_type", send_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (send_type);

     switch( recip -> type ) {
		case 0:
		  gtk_entry_set_text (GTK_ENTRY (send_type), _("To:"));
			break;
		case 1:
		  gtk_entry_set_text (GTK_ENTRY (send_type), _("Cc:"));
			break;
		case 2:
		  gtk_entry_set_text (GTK_ENTRY (send_type), _("Bcc:"));
			break;		
	}	

  address = gtk_entry_new ();
  gtk_widget_set_name (address, "address");
  gtk_widget_ref (address);
  gtk_object_set_data_full (GTK_OBJECT (menuitem), "address", address,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address);
  gtk_box_pack_start (GTK_BOX (hbox11), address, TRUE, TRUE, 0);
	clip_handle_editable (address);


     if (recip -> email)
	{
               if( is_emailv( recip -> email ) )
		{
                         gtk_entry_set_text (GTK_ENTRY (address), recip -> email);
		}
	}

	gtk_widget_grab_focus (address);
	gtk_signal_connect (GTK_OBJECT (address), "activate",
			 GTK_SIGNAL_FUNC (new_message_window_add_recip), (gpointer)newrecip);
			 //GTK_SIGNAL_FUNC (new_message_window_add_recip), (gpointer)recip);
	gtk_signal_connect (GTK_OBJECT (address), "activate",
		GTK_SIGNAL_FUNC (new_message_recip_check), NULL);
	gtk_signal_connect (GTK_OBJECT (address), "changed", 
	                    GTK_SIGNAL_FUNC (new_message_recip_changed), NULL);
	gtk_signal_connect (GTK_OBJECT (button1), "clicked",
	                    GTK_SIGNAL_FUNC (new_message_select_recipients), NULL);	

	return menuitem;
}

void new_message_tree_child_selected (GtkTree *tree, GtkWidget *child) {
	gtk_tree_unselect_child (tree, child);
	if (GTK_IS_HBOX (GTK_BIN (child)->child)) {
		GtkBoxChild *bchild=GTK_BOX (GTK_BIN (child)->child)->children->next->next->data;
		if (GTK_IS_ENTRY (bchild->widget)) {
			gtk_widget_grab_focus (bchild->widget);
		}
	}
}

GtkWidget* create_new_message_window () {
	GList *combo_items=NULL;
	GtkWidget *scratch;
	GtkWidget *window=create_new_message_window2 ();
	RecipSignalData *recip ;


	scratch = pixmap_widget_create (window, PIXMAP_SEND);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window, "send_button")), scratch);

	scratch = pixmap_widget_create (window, PIXMAP_SAVE);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window, "save_button")), scratch);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window,
		"select_categories")), "clicked",
		GTK_SIGNAL_FUNC (calendar_event_categories2), NULL);
        gtk_signal_connect (GTK_OBJECT (lookup_widget (window,
                "msg_exp_label")), "clicked",
                GTK_SIGNAL_FUNC (msgexp_cal), NULL);
        gtk_signal_connect (GTK_OBJECT (lookup_widget (window,
                "replyby_label")), "clicked",
                GTK_SIGNAL_FUNC (replyto_cal), NULL);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "save_button")), "clicked",
	                    GTK_SIGNAL_FUNC (new_message_save), NULL);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem17")), "activate",
	                    GTK_SIGNAL_FUNC (new_message_save), NULL);

	scratch = pixmap_widget_create (window, PIXMAP_PRINT);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window, "print_button")), scratch);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "print_button")), "clicked",
	                    GTK_SIGNAL_FUNC (new_message_print), NULL);

	scratch = pixmap_widget_create (window, PIXMAP_ABOOK);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window, "address_book_button")), scratch);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "address_book_button")), "clicked",
	                    GTK_SIGNAL_FUNC (address_book_clicked), NULL);

	scratch = pixmap_widget_create (window, PIXMAP_SPELL);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window,
					"spell_check_button")), scratch);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window,
			"spell_check_button")),  "clicked",
			GTK_SIGNAL_FUNC (spelling_widget_create), window);

	scratch = pixmap_widget_create (window, PIXMAP_ATTACH);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window, "attach_button")), scratch);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "attach_button")), "clicked",
	                    GTK_SIGNAL_FUNC (new_message_add_attachment), NULL);

	scratch = pixmap_widget_create (window, PIXMAP_CRYPT);
	gtk_widget_show (scratch);
	gtk_container_add (GTK_CONTAINER (lookup_widget (window, "encrypt_button")), scratch);
	gtk_widget_set_sensitive (lookup_widget (window, "encrypt_button"), FALSE);

	/* Allocate a chunk of memory for this new message's recip list */
	recip = (RecipSignalData *)calloc (1, sizeof(RecipSignalData));
	recip->tree = GTK_TREE (lookup_widget (window, "recip_tree"));
	recip->email = NULL;
	recip->type = 0;

        gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "new_message_window")), "size_allocate",
                            GTK_SIGNAL_FUNC (wsize_set_nmsgw), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "new_message_window")), "delete_event",
			    GTK_SIGNAL_FUNC (gtk_false), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "new_message_window")), "destroy",
			    GTK_SIGNAL_FUNC (destroy_new_message_window), (gpointer)recip);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "send_button")), "clicked",
			    GTK_SIGNAL_FUNC (accept_new_message_window), tm_globs->msg_selected);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem2")), "activate",
			    GTK_SIGNAL_FUNC (accept_new_message_window), tm_globs->msg_selected);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem4")), "activate", GTK_SIGNAL_FUNC (make_new_message_window), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem13")), "activate", GTK_SIGNAL_FUNC (address_book_clicked), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem13")), "activate", GTK_SIGNAL_FUNC (abook_widget_add_entry), NULL);


	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem25")), "activate", 
			    GTK_SIGNAL_FUNC (destroy_new_message_window), (gpointer)recip );
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem26")), "activate",
			    GTK_SIGNAL_FUNC (puma_die), NULL);

	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "add_attachment")), "clicked",
	                    GTK_SIGNAL_FUNC (new_message_add_attachment), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "remove_attachment")), "clicked",
	                    GTK_SIGNAL_FUNC (new_message_delete_attachment), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "attachment_clist")), "select_row",
	                    GTK_SIGNAL_FUNC (new_message_attachment_selected), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "attachment_clist")), "unselect_row",
	                    GTK_SIGNAL_FUNC (new_message_attachment_unselected), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem79")), "activate",
	                    GTK_SIGNAL_FUNC (address_book_clicked), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "menuitem78")), "activate",
	                    GTK_SIGNAL_FUNC (new_message_check_names), NULL);
	gtk_signal_connect (GTK_OBJECT (lw (window, "menuitem75")), "activate",
	                    GTK_SIGNAL_FUNC (spelling_widget_create), window);
	gtk_signal_connect (GTK_OBJECT (lw (window, "menuitem99")), "activate",
	                    GTK_SIGNAL_FUNC (activate_aboutbox), NULL);
	combo_items=pop_create_glist ();
	
  gtk_combo_set_popdown_strings (GTK_COMBO (lookup_widget (window, "combo2")), combo_items);
	gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (lookup_widget (window, "combo2"))->entry), tm_globs->default_account);
  g_list_free (combo_items);


	new_message_window_add_recip( NULL, recip ) ;

	gtk_signal_connect (GTK_OBJECT (lw (window, "recip_tree")), "select_child",
	                    GTK_SIGNAL_FUNC (new_message_tree_child_selected), NULL);
	gtk_drag_dest_set (lookup_widget (window, "body_textbox"), GTK_DEST_DEFAULT_ALL, target_table, 
	                   n_targets -1, GDK_ACTION_COPY | GDK_ACTION_MOVE);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "body_textbox")), "drag_data_received",
	                    GTK_SIGNAL_FUNC (new_message_drag_data_received), NULL);
	gtk_signal_connect (GTK_OBJECT (lookup_widget (window, "subject_entry")), "focus-out-event", 
			    GTK_SIGNAL_FUNC (new_msg_subject_changed), NULL);


	clip_handle_editable (lookup_widget (window, "entry9"));   /* Categories? */
	clip_handle_editable (lookup_widget (window, "sensitivity_to_use")); 
	clip_handle_editable (lookup_widget (window, "msg_exp_entry")); 
	clip_handle_editable (lookup_widget (window, "replyby_entry")); 
	clip_handle_editable (lookup_widget (window, "priority_to_use")); 
	clip_handle_editable (lookup_widget (window, "body_textbox"));
	clip_handle_editable (lookup_widget (window, "subject_entry"));
	return window;	
}


void
new_msg_subject_changed (GtkWidget *widget, gpointer data)
{
  GtkWidget *window ;
  char *text ;
  char *newText ;
  int length ;
  char compText[] = "Compose: " ;


  window = lookup_widget (widget, "new_message_window");
  text = gtk_entry_get_text (GTK_ENTRY (widget));
  
  if ( (text) && (length = strlen( text )) )
    {
      newText = malloc( length + strlen(compText) + 1 ) ;
      sprintf( newText, "%s%s", compText, text ) ;
      gtk_window_set_title (GTK_WINDOW (window), newText);
      free( newText ) ;
    }
  else gtk_window_set_title (GTK_WINDOW (window), _("Compose A New Message"));
}
